 /***************************************************************
 * Name:      Mon_Book.cpp
 * Purpose:   Code for the NoteBook class
 * Author:    Jackie Team (jackie.team@gmail.com)
 * Created:   2007-11-26
 * Copyright: Jackie Team (http://musicorganizer.free.fr)
 * License: GNU GPL
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "components.h"
#include <fileref.h>
#include <tag.h>
#include <id3v1tag.h>
#include <id3v2tag.h>
#include <id3v2framefactory.h>
#include <mpegfile.h>


BEGIN_EVENT_TABLE(MonBook, wxNotebook)
    EVT_BUTTON(ID_SAVE,MonBook::button_click)
    EVT_BUTTON(ID_SAVE2,MonBook::button_clickV1)
    EVT_BUTTON(ID_COPIER,MonBook::btnCopyClick)
    EVT_BUTTON(ID_DEPLACER,MonBook::btnMoveClick)
    EVT_BUTTON(ID_APPERCU,MonBook::btnApercuRename)
    EVT_BUTTON(ID_ANNULER,MonBook::btnAnnulerClick)
    EVT_BUTTON(ID_VALIDER,MonBook::btnValiderClick)
    EVT_BUTTON(ID_VALIDER_GEN,MonBook::btnValiderGenClick)
    EVT_BUTTON(ID_COPYTAG,MonBook::btnCopyTag)
    EVT_BUTTON(ID_GEN,MonBook::generateTags)
    //EVT_BUTTON(ID_CLEAN,MonBook::btnCleanID3v2Click)
    EVT_TEXT(ID_COMBOORG,MonBook::textWriting)
    EVT_TEXT(ID_FIC,MonBook::textWriting2)
    EVT_TEXT(ID_ANNEE,MonBook::textWritingNumbers)
    EVT_TEXT(ID_TRACK,MonBook::textWritingNumbers2)
    EVT_MENU(ID_THREAD,MonBook::cpyMoveThreadMsg)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(wxModalFrame,wxFrame)
    EVT_CLOSE ( wxModalFrame::onClose )
END_EVENT_TABLE()

wxModalFrame::wxModalFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style, const wxString& name) : wxFrame(parent,id,title,pos,size,style,name){
    MakeModal(true);
}

void wxModalFrame::onClose(wxCloseEvent &event){
    MakeModal(false);
    Destroy();
}

/***********************************************************************************/

MonBook::MonBook(wxWindow* parent) : wxNotebook(parent,-1)
{

        panelPage1 = new wxPanel(this);
        panelPage2 = new wxPanel(this);
        panelPage3 = new wxPanel(this);
        panelPage4 = new wxPanel(this);
        panelPage5 = new wxPanel(this);
        wxPanel* panGauche = new wxPanel(panelPage1);
        wxPanel* panDroite = new wxPanel(panelPage1);
        wxBoxSizer* sizerPage1 = new wxBoxSizer(wxHORIZONTAL);

        AddPage(panelPage1, _("Tags"));
        AddPage(panelPage2, _("Organize"));
        AddPage(panelPage3, _("Rename"));
        AddPage(panelPage4, _T("ID3V2 -> ID3V1"));
        AddPage(panelPage5, _("Generate"));
        //panelPage1.default=("");
        //Interieur de la page 1
        //id3v2
        wxStaticBox* gpBoxID3v2 = new wxStaticBox(panDroite, wxID_ANY, _T("ID3v2"),wxPoint(0,0));

        new wxStaticText(panDroite, wxID_ANY, _("Title"), wxPoint(15,24));
        comboTitre = new ComboBox(this,panDroite, wxID_ANY,_T(""), wxPoint(70,20), wxSize(200,21),wxArrayString(1,_T("")));
        new wxStaticText(panDroite, wxID_ANY, _("Artist"), wxPoint(15,49));
        comboInterprete = new ComboBox(this,panDroite, wxID_ANY,_T(""), wxPoint(70,45), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Album"), wxPoint(15,74));
        comboAlbum = new ComboBox(this,panDroite, wxID_ANY,_T(""), wxPoint(70,70), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Year"), wxPoint(15,99));
        comboAnne = new ComboBox(this,panDroite, ID_ANNEE,_T(""), wxPoint(70,95), wxSize(70,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Track"), wxPoint(165,99));
        comboPiste = new ComboBox(this,panDroite, ID_TRACK,_T(""), wxPoint(200,95), wxSize(70,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Genre"), wxPoint(15,124));
        comboGenre = new ComboBox(this,panDroite, wxID_ANY,_T(""), wxPoint(70,120), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        wxImage* disq=new wxImage();
        disq->AddHandler(new wxPNGHandler());
        disq->LoadFile(_T("disquette.png"));

        //the buttons
        button_save = new wxBitmapButton(panDroite, ID_SAVE, wxBitmap (*disq), wxPoint(300,15),wxSize(30,31));
        //btnCleanID3V2 = new wxButton(panDroite, ID_CLEAN, _T("Nettoyer les tags"), wxPoint(300,110),wxSize(110,30));

        //id3v1
        wxStaticBox* gpBoxID3v1 = new wxStaticBox(panGauche, wxID_ANY, _T("ID3v1"),wxPoint(0,0),wxSize(350,160));

        new wxStaticText(panGauche, wxID_ANY, _("Title"), wxPoint(15,24));
        comboTitre2 = new ComboBox(this,panGauche, wxID_ANY,_T(""), wxPoint(70,20), wxSize(200,21),wxArrayString(1,_T("")));
        new wxStaticText(panGauche, wxID_ANY, _("Artist"), wxPoint(15,49));
        comboInterprete2 = new ComboBox(this,panGauche, wxID_ANY,_T(""), wxPoint(70,45), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Album"), wxPoint(15,74));
        comboAlbum2 = new ComboBox(this,panGauche, wxID_ANY,_T(""), wxPoint(70,70), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Year"), wxPoint(15,99));
        comboAnne2 = new ComboBox(this,panGauche, ID_ANNEE,_T(""), wxPoint(70,95), wxSize(70,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Track"), wxPoint(165,99));
        comboPiste2 = new ComboBox(this,panGauche, ID_TRACK,_T(""), wxPoint(200,95), wxSize(70,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Genre"), wxPoint(15,124));
        comboGenre2 = new ComboBox(this,panGauche, wxID_ANY,_T(""), wxPoint(70,120), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        button_save2=new wxBitmapButton(panGauche, ID_SAVE2, wxBitmap (*disq), wxPoint(300,15),wxSize(30,31));
        wxGridSizer* sizerPanDroite = new wxGridSizer(1);
        sizerPanDroite->Add(gpBoxID3v2,0, wxEXPAND|wxALL);
        panDroite->SetSizer(sizerPanDroite);
        sizerPage1->Add(panGauche,0, wxEXPAND|wxALL);
        sizerPage1->Add(10,1);
        sizerPage1->Add(panDroite,1, wxEXPAND|wxALL);
        panelPage1->SetSizer(sizerPage1);

        //Interieur de la page 2
        wxPanel* panOrg = new wxPanel(panelPage2);
        wxPanel* panOrgLegende = new wxPanel(panelPage2);
        wxStaticBox* gpBoxOrganisation = new wxStaticBox(panOrg, wxID_ANY, _("Organization"),wxPoint(0,0),wxSize(550,160));
        wxStaticBox* gpBoxOrgLegende = new wxStaticBox(panOrgLegende, wxID_ANY, _("Caption"),wxPoint(0,0));
        wxGridSizer* sizerLegende = new wxGridSizer(1);
        wxBoxSizer* sizerPage2 = new wxBoxSizer(wxHORIZONTAL);

        new wxStaticText(panOrg, wxID_ANY, _("File organization's description:"), wxPoint(15,15));
        comboOrg = new ComboBox(this,panOrg, ID_COMBOORG,_T(""), wxPoint(15,35), wxSize(500,21),wxArrayString(1,_T("")),wxCB_SORT); //Combobox de choix d'organisation des fichiers
        comboOrg->Append(_T("%1/%2"));
        comboOrg->Append(_T("%4/%1"));
        comboOrg->Append(_T("%4/%1/%2"));
        comboOrg->Append(_T("%3/%4"));
        comboOrg->Append(_T("%3/%4/%1"));
        comboOrg->Append(_T("%3/%4/%1/%2"));
        btnCopier = new wxButton(panOrg, ID_COPIER, _("Copy to..."), wxPoint(397,70),wxSize(120,30)); //Bouton "Copier dans..."
        btnDeplacer = new wxButton(panOrg, ID_DEPLACER, _("Move to..."), wxPoint(397,110),wxSize(120,30)); //Bouton "Deplacer dans..."
        new wxStaticText(panOrg, wxID_ANY, _("Keyboarding preview:"), wxPoint(15,60),wxSize(350,15),wxST_NO_AUTORESIZE|wxALIGN_CENTRE);
        DescrSaisie = new wxTextCtrl(panOrg, wxID_ANY, _T(""), wxPoint(15,80),wxSize(350,60),wxTE_MULTILINE|wxST_NO_AUTORESIZE|wxALIGN_CENTRE/*|wxTE_BESTWRAP*/|wxTE_READONLY);
        DescrSaisie->SetBackgroundColour(wxColour(247,247,247));
        infoSaisie = new wxStaticText(panOrgLegende, wxID_ANY, _("%1 : Artist\n%2 : Album\n%3 : Year\n%4 : Genre"), wxPoint(15,15));
        sizerLegende->Add(gpBoxOrgLegende,0, wxEXPAND|wxALL);
        panOrgLegende->SetSizer(sizerLegende);
        sizerPage2->Add(panOrg,0, wxEXPAND|wxALL);
        sizerPage2->Add(10,1);
        sizerPage2->Add(panOrgLegende,1, wxEXPAND|wxALL);
        panelPage2->SetSizer(sizerPage2);

        //Nettoyage des Combobox
        getComboAlbum()->Clear();
        getComboTitre()->Clear();
        getComboInterprete()->Clear();
        getComboPiste()->Clear();
        getComboAlbum2()->Clear();
        getComboTitre2()->Clear();
        getComboInterprete2()->Clear();
        getComboPiste2()->Clear();

        //Interieur de la page 3
        wxPanel* panRen = new wxPanel(panelPage3);
        wxPanel* panRenLegende = new wxPanel(panelPage3);
        wxStaticBox* gpBoxRen = new wxStaticBox(panRen, wxID_ANY, _("Rename"),wxPoint(0,0),wxSize(550,160));
        wxStaticBox* gpBoxRenLegende = new wxStaticBox(panRenLegende, wxID_ANY, _("Caption"),wxPoint(0,0));
        wxGridSizer* sizerRenLegende = new wxGridSizer(1);
        wxBoxSizer* sizerPage3 = new wxBoxSizer(wxHORIZONTAL);

        new wxStaticText(panRen, wxID_ANY, _("Files' name"), wxPoint(15,15));
        comboNomFic = new ComboBox(this,panRen, ID_FIC,_T(""), wxPoint(15,35), wxSize(500,21),wxArrayString(1,_T("")),wxCB_SORT);
        comboNomFic->Append(_T("%2 - %1"));
        comboNomFic->Append(_T("%5 - %1"));
        new wxStaticText(panRen, wxID_ANY, _("Track format:"), wxPoint(390,70));
        comboFormatPiste = new ComboBox(this,panRen, ID_FIC,_T(""), wxPoint(465,67), wxSize(50,21),wxArrayString(0,_T("")),wxCB_READONLY);
        comboFormatPiste->Append(_T("0"));
        comboFormatPiste->Append(_T("00"));
        comboFormatPiste->Append(_T("000"));
        comboFormatPiste->SetValue(_T("00"));
        new wxStaticText(panRenLegende, wxID_ANY, _("%1 : Title \n%2 : Artist \n%3 : Album \n%4 : Year \n%5 : Track \n%6 : Genre"), wxPoint(15,15));;
        btnApercu = new wxButton(panRen, ID_APPERCU, _("Preview"), wxPoint(387,105),wxSize(130,35));
        new wxStaticText(panRen, wxID_ANY, _("Keyboarding preview:"), wxPoint(15,60),wxSize(350,15),wxST_NO_AUTORESIZE|wxALIGN_CENTRE);
        DescrSaisie2 = new wxTextCtrl(panRen, wxID_ANY, _T(""), wxPoint(15,80),wxSize(350,60),wxTE_MULTILINE|wxST_NO_AUTORESIZE|/*wxTE_BESTWRAP|*/wxALIGN_CENTRE|wxTE_READONLY);
        DescrSaisie2->SetBackgroundColour(wxColour(247,247,247));
        sizerRenLegende->Add(gpBoxRenLegende,0, wxEXPAND|wxALL);
        panRenLegende->SetSizer(sizerRenLegende);
        sizerPage3->Add(panRen,0, wxEXPAND|wxALL);
        sizerPage3->Add(10,1);
        sizerPage3->Add(panRenLegende,1, wxEXPAND|wxALL);
        panelPage3->SetSizer(sizerPage3);

        //Interieur de la page 4
        wxPanel* panCopyLeft = new wxPanel(panelPage4);
        wxPanel* panCopyRight = new wxPanel(panelPage4);
        wxStaticBox* gpBoxCopyLeft = new wxStaticBox(panCopyLeft, wxID_ANY, _T("Options"),wxPoint(0,0),wxSize(310,160));
        wxStaticBox* gpBoxCopyRight = new wxStaticBox(panCopyRight, wxID_ANY, _("Copy"),wxPoint(0,0));
        wxGridSizer* sizerCopy = new wxGridSizer(1);
        wxBoxSizer* sizerPage4 = new wxBoxSizer(wxHORIZONTAL);

        long espacement = 90;
        long hauteur = 25;
        chkTitre = new wxCheckBox(panCopyRight, wxID_ANY, _("Title"), wxPoint(15,hauteur));
        chkArtiste = new wxCheckBox(panCopyRight, wxID_ANY, _("Artist"), wxPoint(15 + espacement,hauteur));
        chkGenre = new wxCheckBox(panCopyRight, wxID_ANY, _("Genre"), wxPoint(15 + espacement*2,hauteur));
        chkAlbum = new wxCheckBox(panCopyRight, wxID_ANY, _("Album"), wxPoint(15,hauteur+25));
        chkAnne = new wxCheckBox(panCopyRight, wxID_ANY, _("Year"), wxPoint(15 + espacement,hauteur+25));
        chkPiste = new wxCheckBox(panCopyRight, wxID_ANY, _("Track"), wxPoint(15 + espacement*2,hauteur+25));
        wxString choices[2]={_("Replace all fields"), _("Replace only blank fields")};
        radio = new wxRadioBox(panCopyLeft, wxID_ANY, _("Replacement"), wxPoint(15,hauteur - 5),wxDefaultSize,2,choices,0,wxRA_SPECIFY_ROWS);
        chkNoEmpty = new wxCheckBox(panCopyLeft, wxID_ANY, _("Copy only if source is not blank"), wxPoint(20,hauteur + 70));
        new wxStaticText(panCopyLeft, wxID_ANY, _("Case"), wxPoint(20,hauteur + 95));
        wxString caseChoice[] = {_("No change"),_("Make lower"),_("Make UPPER"),_("Capitalize First Letters")};
        chooseCase = new wxChoice(panCopyLeft, wxID_ANY,wxPoint(100,hauteur + 92),wxDefaultSize, 4,caseChoice);
        btnCopierIdv = new wxButton(panCopyRight, ID_COPYTAG, _("Copy"), wxPoint(15,125));

        sizerCopy->Add(gpBoxCopyRight,0, wxEXPAND|wxALL);
        panCopyRight->SetSizer(sizerCopy);
        sizerPage4->Add(panCopyLeft,0, wxEXPAND|wxALL);
        sizerPage4->Add(10,1);
        sizerPage4->Add(panCopyRight,1, wxEXPAND|wxALL);
        panelPage4->SetSizer(sizerPage4);

        //Interieur de la page 5

        wxPanel* panLeftGen = new wxPanel(panelPage5);
        wxPanel* panRightGen = new wxPanel(panelPage5);
        wxStaticBox* gpBoxLeftGen = new wxStaticBox(panLeftGen, wxID_ANY, _("Tags"),wxPoint(0,0),wxSize(440,160));
        wxStaticBox* gpBoxRightGen = new wxStaticBox(panRightGen, wxID_ANY, _("Options"),wxPoint(0,0));
        wxGridSizer* sizerRightGen = new wxGridSizer(1);
        wxBoxSizer* sizerPage5 = new wxBoxSizer(wxHORIZONTAL);

        new wxStaticText(panLeftGen, wxID_ANY, _("Title"), wxPoint(15,24));
        txtTitreGen = new wxTextCtrl(panLeftGen, wxID_ANY,_T(""), wxPoint(70,20), wxSize(200,21));
        new wxStaticText(panLeftGen, wxID_ANY, _("Artist"), wxPoint(15,49));
        txtInterpreteGen = new wxTextCtrl(panLeftGen, wxID_ANY,_T(""), wxPoint(70,45), wxSize(200,21));
        new wxStaticText(panLeftGen, wxID_ANY, _("Album"), wxPoint(15,74));
        txtAlbumGen = new wxTextCtrl(panLeftGen, wxID_ANY,_T(""), wxPoint(70,70), wxSize(200,21));
        new wxStaticText(panLeftGen, wxID_ANY, _("Year"), wxPoint(15,99));
        comboAnneGen = new ComboBox(this,panLeftGen, ID_ANNEE,_T(""), wxPoint(70,95), wxSize(70,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panLeftGen, wxID_ANY, _("Track"), wxPoint(165,99));
        txtPisteGen = new wxTextCtrl(panLeftGen, ID_TRACK,_T(""), wxPoint(200,95), wxSize(70,21));
        new wxStaticText(panLeftGen, wxID_ANY, _("Genre"), wxPoint(15,124));
        comboGenreGen = new ComboBox(this,panLeftGen, wxID_ANY,_T(""), wxPoint(70,120), wxSize(200,21),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticBox(panLeftGen, wxID_ANY, _("Caption"),wxPoint(280,10),wxSize(155,115));
        new wxStaticText(panLeftGen, wxID_ANY, _("%1 - %99 : Words \nbetween separators \nSeparators : Values \nseparated by ':' \n(without quotes)"), wxPoint(286,23));
        btnGen = new wxButton(panLeftGen, ID_GEN, _("Generate !"), wxPoint(315,129));

        chkGenAll = new wxCheckBox(panRightGen, wxID_ANY, _("Generate ID3V1 and ID3V2"), wxPoint(20,20));
        chkNoEmptyGen = new wxCheckBox(panRightGen, wxID_ANY, _("Copy only if source is not blank"), wxPoint(20,40));
        radioGen = new wxRadioBox(panRightGen, wxID_ANY, _("Replacement"), wxPoint(15,60),wxDefaultSize,2,choices,0,wxRA_SPECIFY_ROWS);
        new wxStaticText(panRightGen, wxID_ANY, _("Separators"), wxPoint(20,137));
        txtSeparator = new wxTextCtrl(panRightGen, wxID_ANY, _T("_-_:"), wxPoint(95,135),wxSize(125,20),wxST_NO_AUTORESIZE/*|wxTE_BESTWRAP*/);

        sizerRightGen->Add(gpBoxRightGen,0, wxEXPAND|wxALL);
        panRightGen->SetSizer(sizerRightGen);
        sizerPage5->Add(panLeftGen,0, wxEXPAND|wxALL);
        sizerPage5->Add(10,1);
        sizerPage5->Add(panRightGen,1, wxEXPAND|wxALL);
        panelPage5->SetSizer(sizerPage5);

        //On initialise les genres et les annÃ©es
        for (int i=0 ; i<=125 ; i++){
            comboGenre->Append(GENRES[i]);
            comboGenre2->Append(GENRES[i]);
            comboGenreGen->Append(GENRES[i]);
        }
        for (int i=0 ; i<=201 ; i++){
            comboAnne->Append(wxString::Format(_T("%d"),1850 +i));
            comboAnne2->Append(wxString::Format(_T("%d"),1850 +i));
            comboAnneGen->Append(wxString::Format(_T("%d"),1850 +i));
        }
        restoreTabs();


}

void MonBook::setChoicebook(MonChoicebook* c){
    cb=c;
}

void MonBook::setArbo(MonArbo* a){
    arbo=a;
}


void MonBook::button_click(wxCommandEvent& event){
    if(cb->getMListeV2()->GetSelectedItemCount()==0)
        return;
    //Les changements ne pouvant pas etre annules, on previent l'utilisateur
    wxMessageDialog dlg_info(NULL,_("Save changes?"),_("Warning!"), wxICON_EXCLAMATION | wxYES_NO);
    int res=dlg_info.ShowModal();
    dlg_info.Destroy();

    if (res==wxID_NO)
      return ;
    MaListe* l=cb->getMListeV2();
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)l->GetSelectedItemCount() ; i++){
       currentSel= l->getSelection(AncienneSel);
       wxString currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
       TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
       ff->setDefaultTextEncoding(TagLib::String::UTF8);
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
       fic.setID3v2FrameFactory(ff);


        if(comboTitre->GetValue()!=_("<Title>") ){
            TagLib::String s((char const*)comboTitre->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboTitre->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setTitle(TagLib::String::null);
            else
                fic.ID3v2Tag(true)->setTitle(s);
            l->SetItem(currentSel,MaListe::TITLE_COL,comboTitre->GetValue());
        }

        if(comboInterprete->GetValue()!=_("<Artist>") ){
            TagLib::String s((char const*)comboInterprete->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboInterprete->GetValue()==_T("")){
                //wxMessageBox(_T("aaa"));
                fic.ID3v2Tag(true)->setArtist(TagLib::String::null);
            }else
                fic.ID3v2Tag(true)->setArtist(s);
            l->SetItem(currentSel,MaListe::ARTIST_COL,comboInterprete->GetValue());
        }

        if(comboAlbum->GetValue()!=_("<Album>") ){
            TagLib::String s((char const*)comboAlbum->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboAlbum->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setAlbum(TagLib::String::null);
            else
                fic.ID3v2Tag(true)->setAlbum(s);
            l->SetItem(currentSel,MaListe::ALBUM_COL,comboAlbum->GetValue());
        }

        if(comboAnne->GetValue()!=_("<Year>") ){
            long y=0;
            if(comboAnne->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setYear(0);
            else{
                try{
                    comboAnne->GetValue().ToLong(&y);
                    fic.ID3v2Tag(true)->setYear((int)y);
                }catch(...){
                }
            }
            if(y==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::YEAR_COL,comboAnne->GetValue());
        }

        if(comboPiste->GetValue()!=_("<Track>") ){
            long t=0;
            if(comboPiste->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setTrack(0);
            else{
                try{
                    comboPiste->GetValue().ToLong(&t);
                    fic.ID3v2Tag(true)->setTrack((int)t);
                }catch(...){
                }
            }
            if(t==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::TRACK_COL,comboPiste->GetValue());
        }

        if(comboGenre->GetValue()!=_("<Genre>") ){
            TagLib::String s((char const*)comboGenre->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboGenre->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setGenre(TagLib::String::null);
            else
                fic.ID3v2Tag(true)->setGenre(s);
            l->SetItem(currentSel,MaListe::GENRE_COL,comboGenre->GetValue());
        }

        fic.save(TagLib::MPEG::File::ID3v2,false);//On ne sauvegarde que les ID3v2
        AncienneSel = currentSel;

    }

}

void MonBook::button_clickV1(wxCommandEvent& event){
    if(cb->getMListeV2()->GetSelectedItemCount()==0)
        return;
    //Les changements ne pouvant pas etre annules, on previent l'utilisateur
    wxMessageDialog dlg_info(NULL,_("Save changes?"),_("Warning!"), wxICON_EXCLAMATION | wxYES_NO);
    int res=dlg_info.ShowModal();
    dlg_info.Destroy();

    if (res==wxID_NO)
      return ;
    MaListe* l=cb->getMListeV1();
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)l->GetSelectedItemCount() ; i++){
       currentSel = l->getSelection(AncienneSel);
       wxString currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);

        if(comboTitre2->GetValue()!=_("<Title>") ){
            TagLib::String t((char const*)comboTitre2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboTitre2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setTitle(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setTitle(t);
            l->SetItem(currentSel,MaListe::TITLE_COL,comboTitre2->GetValue());
        }

        if(comboInterprete2->GetValue()!=_("<Artist>") ){
            TagLib::String s((char const*)comboInterprete2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboInterprete2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setArtist(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setArtist(s);
            l->SetItem(currentSel,MaListe::ARTIST_COL,comboInterprete2->GetValue());
        }

        if(comboAlbum2->GetValue()!=_("<Album>") ){
            TagLib::String s((char const*)comboAlbum2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboAlbum2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setAlbum(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setAlbum(s);
            l->SetItem(currentSel,MaListe::ALBUM_COL,comboAlbum2->GetValue());
        }


        if(comboAnne2->GetValue()!=_("<Year>") ){
            long y=0;
            if(comboAnne2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setYear(0);
            else{
                try{
                    comboAnne2->GetValue().ToLong(&y);
                    fic.ID3v1Tag(true)->setYear((int)y);
                }catch(...){
                }
            }
            if(y==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::YEAR_COL,comboAnne2->GetValue());
        }


        if(comboPiste2->GetValue()!=_("<Track>") ){
            long t=0;
            if(comboPiste2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setTrack(0);
            else{
                try{
                    comboPiste2->GetValue().ToLong(&t);
                    fic.ID3v1Tag(true)->setTrack((int)t);
                }catch(...){
                }
            }
            if(t==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::TRACK_COL,comboPiste2->GetValue());
        }


        if(comboGenre2->GetValue()!=_("<Genre>") ){
            TagLib::String s((char const*)comboGenre2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboGenre2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setGenre(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setGenre(s);
            l->SetItem(currentSel,MaListe::GENRE_COL,comboGenre2->GetValue());
        }

        fic.save(TagLib::MPEG::File::ID3v1,false);//On ne sauvegarde que les ID3v1
        AncienneSel = currentSel;

    }

}

void MonBook::cleanStr(wxString& str,wxString& replace){

    wxRegEx eexp(wxT("[\xE8\xE9\xEA\xEB]"));
    wxRegEx euexp(wxT("[\xC8\xC9\xCA\xCB]"));
    wxRegEx aexp(wxT("[\xE0\xE1\xE2\xE3\xE4\xE5]"));
    wxRegEx auexp(wxT("[\xC0\xC1\xC2\xC3\xC4\xC5]"));
    wxRegEx iexp(wxT("[\xEC\xED\xEE\xEF]"));
    wxRegEx iuexp(wxT("[\xCC\xCD\xCE\xCF]"));
    wxRegEx oexp(wxT("[\xF2\xF3\xF4\xF5\xF6]"));
    wxRegEx ouexp(wxT("[\xD2\xD3\xD4\xD5\xD6]"));
    wxRegEx uexp(wxT("[\xF9\xFA\xFB\xFC]"));
    wxRegEx uuexp(wxT("[\xD9\xDA\xDB\xDC]"));
    wxRegEx invalid_chars(wxT("[^a-zA-Z0-9/ ().,;_&-]"));

    eexp.Replace(&str,wxString(_T("e")),0);
    euexp.Replace(&str,wxString(_T("E")),0);wxRegEx exp(wxT("%([1-9][0-9])"));
    aexp.Replace(&str,wxString(_T("a")),0);
    auexp.Replace(&str,wxString(_T("A")),0);
    iexp.Replace(&str,wxString(_T("i")),0);
    iuexp.Replace(&str,wxString(_T("I")),0);
    oexp.Replace(&str,wxString(_T("o")),0);
    ouexp.Replace(&str,wxString(_T("O")),0);
    uexp.Replace(&str,wxString(_T("u")),0);
    uuexp.Replace(&str,wxString(_T("U")),0);
    str.Replace(wxT("\xE7"),wxT("c"));
    str.Replace(wxT("\xC7"),wxT("C"));
    invalid_chars.Replace(&str,replace,0);
    str.Replace(_T("\0"),_T(""));


}

void MonBook::btnCopyClick(wxCommandEvent& event){
    MaListe* l=cb->getMListeV2();
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxDirDialog folder(this,_("Please choose a directory"));
            if(folder.ShowModal()==wxID_OK){
                //Recuperation du dossier dans lequel l'utilisateur desire organiser sa musique
                wxString dossier=folder.GetPath();
                wxString annee,album,artiste,genre;
                //Operation sur la saisie :
                // - On remplace les "%1", "%2", "%3", et "%4" par ce qui y correspond, pour chaque fichier selectionne
                progBar=new wxProgressDialog(_("Please wait"),_("Files are beeing copied..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(l,this,dossier);
                thread->Create();
                thread->Run();
            }
        }
    }
}

void MonBook::btnMoveClick(wxCommandEvent& event){
    MaListe* l=cb->getMListeV2();
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxDirDialog folder(this,_("Please choose a directory"));
            if(folder.ShowModal()==wxID_OK){
                //Recuperation du dossier dans lequel l'utilisateur dÃ©sire organiser sa musique
                wxString dossier=folder.GetPath();
                wxString annee,album,artiste,genre;
                //Operation sur la saisie :
                // - On remplace les "%1", "%2", "%3", et "%4" par ce qui y correspond, pour chaque fichier selectionne
                progBar=new wxProgressDialog(_("Please wait"),_("Files are beeing moved..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(l,this,dossier,true);
                thread->Create();
                thread->Run();

            }
        }
    }
}

wxString MonBook::ucwords(const wxString& s, int action){
    wxString res(s);
    if (action == MAKE_UPPER) res.MakeUpper();
    else if (action == MAKE_LOWER) res.MakeLower();
    else if (action == MAKE_FWL_UPPER){
        res = wxEmptyString;
        wxStringTokenizer tkz(s,wxT("\t\r\n ") + OptionsHandler::getOption(_T("/notebook/capitalize"),wxString(wxT("0123456789{}()[].~`!@#$%^&*-_+=|\\:;\"<>,?/"))),wxTOKEN_RET_DELIMS);//split la chaine sur le caractï¿œre '/'
        while(tkz.HasMoreTokens() ){
            wxString token = tkz.GetNextToken();
            res+=token.Mid(0,1).MakeUpper()+token.Mid(1).MakeLower();
        }
    }
    return res;

}

void MonBook::btnApercuRename(wxCommandEvent& event){
    MaListe* l=cb->getCurrentList();
    if( comboNomFic->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
                wxString annee,album,artiste,genre;
                //Operation sur la saisie :
                // - On remplace les "%1", "%2", "%3", et "%4" par ce qui y correspond, pour chaque fichier selectionne
                int h=0;
                listeNoms.Clear();
                listeNoms2.Clear();
                wxArrayString listeAnciensNoms;
                wxArrayString listeNouveauxNoms;
                long AncienneSel = l->getSelection(-2);
                for (h=0 ; h<l->GetSelectedItemCount() ; h++){
                    wxString artiste = l->getSelRowText(MaListe::ARTIST_COL,AncienneSel);
                    wxString titre = l->getSelRowText(MaListe::TITLE_COL,AncienneSel);
                    wxString album = l->getSelRowText(MaListe::ALBUM_COL,AncienneSel);
                    wxString annee = l->getSelRowText(MaListe::YEAR_COL,AncienneSel);
                    wxString genre = l->getSelRowText(MaListe::GENRE_COL,AncienneSel);
                    wxString piste = l->getSelRowText(MaListe::TRACK_COL,AncienneSel);
                    wxString SaisieStr,dir,currentName,currentDir;
                    SaisieStr = comboNomFic->GetValue();
                    SaisieStr.Replace(_T("%1"), titre.Trim());
                    SaisieStr.Replace(_T("%2"), artiste.Trim());
                    SaisieStr.Replace(_T("%3"), album.Trim());
                    SaisieStr.Replace(_T("%4"), annee.Trim());
                    long numPiste;
                    piste.ToLong(&numPiste);
                    wxString format = _T("%02d");
                    if(comboFormatPiste->GetValue() == _T("0")){
                          format = _T("%01d");
                    }else if(comboFormatPiste->GetValue() == _T("000")){
                          format = _T("%03d");
                    }
                    SaisieStr.Replace(_T("%5"), wxString::Format(format,numPiste));
                    SaisieStr.Replace(_T("%6"), genre.Trim());

                    wxString rchar=OptionsHandler::getOption(_T("/notebook/replace_char"),wxString(_T("_")));
                    if(rchar==_T(""))
                        rchar=_T("_");
                    SaisieStr.Replace(_T("\""),rchar);
	                cleanStr(SaisieStr,rchar);
                    currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
                    currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
                    dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
                    //On recupere son extension pour la rajoutee
                    wxFileName fn(currentName);
                    wxString ext = fn.GetExt();
                    wxString newName = SaisieStr;
                    newName = wxString::Format(newName + _T("%c") + ext,_T('.'));

                    listeAnciensNoms.Add(currentName);
                    listeNouveauxNoms.Add(newName);
                    newName.Printf(l->getSelRowText(MaListe::DIR_COL,AncienneSel)+_T("%c")+newName,wxFileName::GetPathSeparator());
                    listeNoms.Add(dir);
                    listeNoms2.Add(newName);

                    AncienneSel = l->getSelection(AncienneSel);
                }
                containList = new wxModalFrame(this, wxID_ANY, _("Rename"), wxPoint(200,200), wxSize(800,600),wxDEFAULT_FRAME_STYLE|wxFRAME_FLOAT_ON_PARENT);
                containList->SetBackgroundColour(wxColour(230,230,230));
                //On crÃ©e la liste  (munie de CheckBoxs)
                LstBox = new wxCheckListCtrl(containList);
                LstBox->InsertColumn(0, _("Old name"));
                LstBox->InsertColumn(1, _("New name"));
                LstBox->InsertColumn(2, _("State"));
                LstBox->SetColumnWidth(0, 360);
                LstBox->SetColumnWidth(1, 360);
                LstBox->SetColumnWidth(2, 70);
                //On crÃ©e les bouton "valider" et "annuler" et on les placent dans le fenetre
                wxBoxSizer* sizer3=new wxBoxSizer(wxHORIZONTAL);
                wxBoxSizer* sizer4=new wxBoxSizer(wxVERTICAL);
                btnAnnuler = new wxButton(containList,ID_ANNULER,_("Cancel"));
                btnValider = new wxButton(containList,ID_VALIDER,_("OK"));
                sizer4->Add(LstBox,1, wxALL|wxEXPAND);
                sizer3->Add(btnValider,0);
                sizer3->Add(8,0,0);
                sizer3->Add(btnAnnuler,0,wxALL|wxEXPAND);
                sizer3->Add(8,0,0);
                sizer4->Add(0,8,0);
                sizer4->Add(sizer3,0,wxALIGN_RIGHT|wxALIGN_BOTTOM);
                sizer4->Add(0,8,0);
                containList->SetSizer(sizer4);
                containList->Centre();
                containList->Show();
                containList->Maximize();
                //On insere tout ce qui est nÃÂ©cessaire dans la liste
                //Et l'on coche ce qu'il faut
                long int k = 0;
                AncienneSel = l->getSelection(-2);
                for (k=0 ;(unsigned int)k<listeAnciensNoms.GetCount();k++){
                    LstBox->InsertItem(k,listeAnciensNoms.Item(k));
                    LstBox->SetItem(k,1,listeNouveauxNoms.Item(k));
                    LstBox->SetIcon(k,0);
                    wxString cur = comboNomFic->GetValue();
                    if (cur.Find(_T("%1")) != wxNOT_FOUND){
                        if (l->getSelRowText(1,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%2")) != wxNOT_FOUND){
                        if (l->getSelRowText(2,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%3")) != wxNOT_FOUND){
                        if (l->getSelRowText(3,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%4")) != wxNOT_FOUND){
                        if (l->getSelRowText(4,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%5")) != wxNOT_FOUND){
                        if (l->getSelRowText(6,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%6")) != wxNOT_FOUND){
                        if (l->getSelRowText(5,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }

                }


            }
        }

}

void MonBook::updateDescrSaisie(){
    wxString s = comboOrg->GetValue();
    if (s == _T(""))
        DescrSaisie->SetLabel(_T(""));
    wxRegEx invalid(wxT("[\\:*?\"<>|]"));
    if (invalid.Matches(s)){
        comboOrg->SetValue(text1);
        comboOrg->SetInsertionPointEnd();
        s = text1;
    }else{
        text1 = s;
    }
    s.Replace(_T("%1"), _("<Artist>"));
    s.Replace(_T("%2"), _("<Album>"));
    s.Replace(_T("%3"), _("<Year>"));
    s.Replace(_T("%4"), _("<Genre>"));
    DescrSaisie->SetValue(s);
}

void MonBook::updateDescrSaisie2(){
    wxString s = comboNomFic->GetValue();
    if (s == _T(""))
        DescrSaisie->SetLabel(_T(""));
    wxRegEx invalid(wxT("[\\:*?\"<>|/]"));
    if (invalid.Matches(s)){
        comboNomFic->SetValue(text2);
        comboNomFic->SetInsertionPointEnd();
        s = text2;
    }else{
        text2 = s;
    }
    s.Replace(_T("%1"), _("<Title>"));
    s.Replace(_T("%2"), _("<Artist>"));
    s.Replace(_T("%3"), _("<Album>"));
    s.Replace(_T("%4"), _("<Year>"));
    s.Replace(_T("%5"), _("<Track>"));
    s.Replace(_T("%6"), _("<Genre>"));
    DescrSaisie2->SetValue(s);
}


void MonBook::textWriting(wxCommandEvent& event){
     updateDescrSaisie();
}

void MonBook::textWriting2(wxCommandEvent& event){
     updateDescrSaisie2();
}

void MonBook::textWritingNumbers2(wxCommandEvent& event){
    wxString s = comboPiste->GetValue();
    long offset=0;
#ifdef __WXMSW__
    offset=1;
#else
    if(s.Length()==0)
        offset=1;
#endif
    if (not s.IsNumber())
        comboPiste->Remove(comboPiste->GetLastPosition() - offset,comboPiste->GetLastPosition()-offset+1);
    else{
        long len;
        s.ToLong(&len);
        if (len > 9999)
            comboPiste->Remove(comboPiste->GetLastPosition() -offset,comboPiste->GetLastPosition()-offset+1);
    }

}

void MonBook::textWritingNumbers(wxCommandEvent& event){
    wxString s = comboAnne->GetValue();
    long offset=0;
#ifdef __WXMSW__
    offset=1;
#else
    if(s.Length()==0)
        offset=1;
#endif
    if (not s.IsNumber())
        comboAnne->Remove(comboAnne->GetLastPosition()- offset,comboAnne->GetLastPosition()-offset+1);
    else{
        long len;
        s.ToLong(&len);
        if (len > 9999)
            comboAnne->Remove(comboAnne->GetLastPosition() -offset,comboAnne->GetLastPosition()-offset+1);
    }

}

void MonBook::btnAnnulerClick(wxCommandEvent& event){
    containList->Close();
}

void MonBook::btnValiderClick(wxCommandEvent& event){
    int h=0;
    MaListe *l=cb->getCurrentList();
    MaListe *l2=cb->getOtherList();
    long AncienneSel = l->getSelection(-2);
    wxString n;
    wxListItem i;
    i.SetMask(wxLIST_MASK_TEXT);
    i.SetColumn(1);
    for (h=0 ; h<LstBox->GetItemCount();h++){
        if (LstBox->IsChecked((long)h)){
            AncienneSel = l->getSelection(AncienneSel);
            try{
                wxRenameFile(listeNoms[h],listeNoms2[h]);
                LstBox->SetItem(h,2,_("<OK>"));
                i.SetId(h);
                LstBox->GetItem(i);
                n=i.GetText();
                l->SetItem(AncienneSel,0,n);
                l2->SetItem(AncienneSel,0,n);
            }catch(...){
                LstBox->SetItem(h,2,_("<ERROR>"));
            }
        }
    }
    btnAnnuler->SetLabel(_("Close"));
    btnValider->Destroy();
}

void MonBook::btnValiderGenClick(wxCommandEvent& event){
    int h=0;
    bool ID3V1and2 = chkGenAll->IsChecked();
    bool dontCopyEmptySource = chkNoEmptyGen->IsChecked();
    int copyOnlyEmptyTarget = radioGen->GetSelection();
    bool isID3V2 = cb->isID3V2();

    MaListe *l=cb->getCurrentList();
    MaListe* otherLst = cb->getOtherList();
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    wxString titreStr,artistStr,albumStr,yearStr,genreStr,trackStr;
    wxListItem titre,artist,album,year,genre,track;
    titre.SetMask(wxLIST_MASK_TEXT);
    artist.SetMask(wxLIST_MASK_TEXT);
    album.SetMask(wxLIST_MASK_TEXT);
    year.SetMask(wxLIST_MASK_TEXT);
    genre.SetMask(wxLIST_MASK_TEXT);
    track.SetMask(wxLIST_MASK_TEXT);
    titre.SetColumn(1);
    artist.SetColumn(2);
    album.SetColumn(3);
    year.SetColumn(4);
    genre.SetColumn(5);
    track.SetColumn(6);
    for (h=0 ; h < LstBox->GetItemCount();h++){
        currentSel = l->getSelection(AncienneSel);
        wxString currentDir = l->getSelRowText(MaListe::DIR_COL,AncienneSel);
        wxString currentName = l->getSelRowText(MaListe::NAME_COL,AncienneSel);
        wxString dir;
        dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
        TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
        ff->setDefaultTextEncoding(TagLib::String::UTF8);
        TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
        fic.setID3v2FrameFactory(ff);
        if (LstBox->IsChecked((long)h)){
            titre.SetId(h);
            artist.SetId(h);
            album.SetId(h);
            year.SetId(h);
            genre.SetId(h);
            track.SetId(h);
            LstBox->GetItem(titre);
            LstBox->GetItem(artist);
            LstBox->GetItem(album);
            LstBox->GetItem(year);
            LstBox->GetItem(genre);
            LstBox->GetItem(track);
            titreStr = titre.GetText();
            artistStr = artist.GetText();
            albumStr = album.GetText();
            yearStr = year.GetText();
            genreStr = genre.GetText();
            trackStr = track.GetText();
            try{
                //ecriture des tags
                if (ID3V1and2 || isID3V2){
                    if (!(trackStr == _T("") && dontCopyEmptySource)){
                        long t;
                        trackStr.ToLong(&t);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TRACK_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            fic.ID3v2Tag(true)->setTrack((int)t);
                        }
                    }
                    if (!(genreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)genreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::GENRE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            fic.ID3v2Tag(true)->setGenre(s);
                        }
                    }
                    if (!(yearStr == _T("") && dontCopyEmptySource)){
                        long y;
                        yearStr.ToLong(&y);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::YEAR_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            fic.ID3v2Tag(true)->setYear((int)y);
                        }
                    }
                    if (!(artistStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)artistStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ARTIST_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            fic.ID3v2Tag(true)->setArtist(s);
                        }
                    }
                    if (!(albumStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)albumStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ALBUM_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            fic.ID3v2Tag(true)->setAlbum(s);
                        }
                    }
                    if (!(titreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)titreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TITLE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            fic.ID3v2Tag(true)->setTitle(s);
                        }
                    }
                }
                if(ID3V1and2 || !(isID3V2)){
                    if (!(trackStr == _T("") && dontCopyEmptySource)){
                        long t;
                        trackStr.ToLong(&t);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TRACK_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            fic.ID3v1Tag(true)->setTrack((int)t);
                        }
                    }
                    if (!(genreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)genreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::GENRE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            fic.ID3v1Tag(true)->setGenre(s);
                        }
                    }
                    if (!(yearStr == _T("") && dontCopyEmptySource)){
                        long y;
                        yearStr.ToLong(&y);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::YEAR_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            fic.ID3v1Tag(true)->setYear((int)y);
                        }
                    }
                    if (!(artistStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)artistStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ARTIST_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            fic.ID3v1Tag(true)->setArtist(s);
                        }
                    }
                    if (!(albumStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)albumStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ALBUM_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            fic.ID3v1Tag(true)->setAlbum(s);
                        }
                    }
                    if (!(titreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)titreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TITLE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            fic.ID3v1Tag(true)->setTitle(s);
                        }
                    }
                }
                LstBox->SetItem(h,7,_("<OK>"));
            }catch(...){
                LstBox->SetItem(h,7,_("<ERROR>"));
            }
        }
        if (ID3V1and2 || isID3V2)
            fic.save(TagLib::MPEG::File::ID3v2,false);
        if(ID3V1and2 || !(isID3V2))
            fic.save(TagLib::MPEG::File::ID3v1,false);
        AncienneSel = l->getSelection(AncienneSel);
    }
    btnAnnuler->SetLabel(_("Close"));
    btnValider->Destroy();
}

void MonBook::cpyMoveThreadMsg(wxCommandEvent& event){
    int type=event.GetInt();
    if(type==-1){//mise Ã  jour de la progBar
        if(!progBar->Update(thread->getProg()))
            thread->end();
    }else{
        progBar->Destroy();
        if (type != 0){
            if (type == 1){
                wxMessageDialog msg(NULL,_("1 error while performing task"), _("Error"),wxICON_HAND|wxOK);
                msg.ShowModal();
            }else{
                wxString err=wxString::Format(_T("%d"),type);
                wxMessageDialog msg(NULL,err + _(" errors while performing task"), _("Error"),wxICON_HAND|wxOK);
                msg.ShowModal();
            }
        }

        arbo->refresh();
    }
}

void MonBook::saveTabs(){
    if(OptionsHandler::getOption(_T("/notebook/save_content"),true)==false)
        return;
    OptionsHandler::setOption(_T("/notebook/comboCopyMove_val"),comboOrg->GetValue());
    OptionsHandler::setOption(_T("/notebook/comboRename_val"),comboNomFic->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_4/replace"),radio->GetSelection());
    OptionsHandler::setOption(_T("/notebook/tab_4/copie"),chkNoEmpty->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/title"),chkTitre->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/artist"),chkArtiste->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/album"),chkAlbum->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/genre"),chkGenre->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/track"),chkPiste->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/year"),chkAnne->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/capitalize"),chooseCase->GetSelection());
    //Tab 5
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_ID3V1and2"),chkGenAll->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_no_empty"),chkNoEmptyGen->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_replace"),radioGen->GetSelection());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_separators"),txtSeparator->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_title"),txtTitreGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_artist"),txtInterpreteGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_album"),txtAlbumGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_year"),comboAnneGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_track"),txtPisteGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_genre"),comboGenreGen->GetValue());
}

void MonBook::restoreTabs(){
    if(OptionsHandler::getOption(_T("/notebook/save_content"),true)==false)
        return;
    comboOrg->SetValue(OptionsHandler::getOption(_T("/notebook/comboCopyMove_val")));
    comboNomFic->SetValue(OptionsHandler::getOption(_T("/notebook/comboRename_val")));
    wxString str;
    radio->SetSelection(OptionsHandler::getOption(_T("/notebook/tab_4/replace"),false));
    chkNoEmpty->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/copie"),true));
    chkTitre->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/title"),false));
    chkArtiste->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/artist"),false));
    chkAlbum->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/album"),false));
    chkGenre->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/genre"),false));
    chkPiste->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/track"),false));
    chkAnne->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/year"),false));
    chooseCase->SetSelection(OptionsHandler::getOption(_T("/notebook/tab_4/capitalize"),0));
    //Tab 5
    chkGenAll->SetValue(OptionsHandler::getOption(_T("/notebook/tab_5/gen_ID3V1and2"),false));
    chkNoEmptyGen->SetValue(OptionsHandler::getOption(_T("/notebook/tab_5/gen_no_empty"),true));
    radioGen->SetSelection(OptionsHandler::getOption(_T("/notebook/tab_5/gen_replace"),1));
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_separators"),wxString(_T("_-_:")));
    if (str == _T(""))
        str = _T("_-_:");
    txtSeparator->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_title"));
    txtTitreGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_artist"));
    txtInterpreteGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_album"));
    txtAlbumGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_year"));
    comboAnneGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_track"));
    txtPisteGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_genre"));
    comboGenreGen->SetValue(str);

    updateDescrSaisie2();
    updateDescrSaisie();
}

void MonBook::gen(wxString& ret, wxString str, wxString regex){
    wxRegEx exp(regex);
    exp.Replace(&str,wxString(_T("|")));
    //Decoupage du nom de fichier en Array
    wxArrayString liste; // liste correpondante aux %1 - %99
    while (str.Find(_T('|')) != wxNOT_FOUND){
        int j = str.Find(_T('|'));
        wxString tmpSep;
        if (j != 0)
            liste.Add(str.SubString(0,j - 1));
        if ((unsigned int)(j+1) >= str.Len())
            str = _T("");
        else
            str = str.SubString(j+1,str.Len()-1);
    }
    liste.Add(str.SubString(0,str.Len()-1));
    //Remplacement
    char chiffre[2];
    for (int i=1; i<=99;i++){
        sprintf(chiffre,"%d",i);
        if ((unsigned int)i > liste.GetCount())
            ret.Replace(wxString(_T("%")) + wxString(chiffre,wxConvUTF8),_T(""));
        else
            ret.Replace(wxString(_T("%")) + wxString(chiffre,wxConvUTF8),liste[i-1]);
    }
}

void MonBook::generateTags(wxCommandEvent& event){
    MaListe* l = cb->getCurrentList();
    if( l->GetSelectedItemCount()==0){
        wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
        msg.ShowModal();
    }else{
        wxString titre,piste,annee,album,artiste,genre,nom;
        int h=0;
        listeNoms.Clear();
        listeNoms2.Clear();
        wxArrayString listeAnciensNoms;
        wxArrayString listeNouveauxNoms;

        containList = new wxModalFrame(this, wxID_ANY, _("Rename"), wxPoint(200,200), wxSize(800,600),wxDEFAULT_FRAME_STYLE|wxFRAME_FLOAT_ON_PARENT);
        containList->SetBackgroundColour(wxColour(230,230,230));
        //On crÃ©e la liste  (munie de CheckBoxs)
        LstBox = new wxCheckListCtrl(containList);
        LstBox->InsertColumn(0, _("Name"));
        LstBox->InsertColumn(1, _("Titre"));
        LstBox->InsertColumn(2, _("Artist"));
        LstBox->InsertColumn(3, _("Album"));
        LstBox->InsertColumn(4, _("Year"));
        LstBox->InsertColumn(5, _("Genre"));
        LstBox->InsertColumn(6, _("Track"));
        LstBox->InsertColumn(7, _("State"));
        LstBox->SetColumnWidth(0, 360);
        LstBox->SetColumnWidth(1, 140);
        LstBox->SetColumnWidth(2, 100);
        LstBox->SetColumnWidth(3, 100);
        LstBox->SetColumnWidth(4, 80);
        LstBox->SetColumnWidth(5, 100);
        LstBox->SetColumnWidth(6, 60);
        LstBox->SetColumnWidth(7, 70);
        //On crÃ©e les bouton "valider" et "annuler" et on les placent dans le fenetre
        wxBoxSizer* sizer3=new wxBoxSizer(wxHORIZONTAL);
        wxBoxSizer* sizer4=new wxBoxSizer(wxVERTICAL);
        btnAnnuler = new wxButton(containList,ID_ANNULER,_("Cancel"));
        btnValider = new wxButton(containList,ID_VALIDER_GEN,_("OK"));
        sizer4->Add(LstBox,1, wxALL|wxEXPAND);
        sizer3->Add(btnValider,0);
        sizer3->Add(8,0,0);
        sizer3->Add(btnAnnuler,0,wxALL|wxEXPAND);
        sizer3->Add(8,0,0);
        sizer4->Add(0,8,0);
        sizer4->Add(sizer3,0,wxALIGN_RIGHT|wxALIGN_BOTTOM);
        sizer4->Add(0,8,0);
        containList->SetSizer(sizer4);

        long AncienneSel = l->getSelection(-2);
        for (h=0 ; h<l->GetSelectedItemCount() ; h++){
            nom = l->getSelRowText(MaListe::NAME_COL,AncienneSel);  //abcd.mp3
            nom = nom.Remove(nom.Find(_T('.'),true));               //abcd
            wxString dir,currentName,currentDir;
            titre = txtTitreGen->GetValue();
            artiste = txtInterpreteGen->GetValue();
            album = txtAlbumGen->GetValue();
            annee = comboAnneGen->GetValue();
            piste = txtPisteGen->GetValue();
            genre = comboGenreGen->GetValue();
            wxString reg;
            wxString sep = txtSeparator->GetValue();
            //Expression reguliere a partir des separateurs
            while (sep.Find(_T(':')) != wxNOT_FOUND){
                int j = sep.Find(_T(':'));
                if (sep.Len() == 1){
                    sep = _T("");
                }else{
                    if (j == 0){
                        sep = sep.SubString(1,sep.Len()-1);
                    }else if((unsigned int)(j+1) >= sep.Len()){
                        sep = sep.SubString(0,sep.Len()-2);
                        reg += _T("(") + sep + _T(")|");
                    }else{
                        reg += _T("(") + sep.SubString(0,j - 1) + _T(")|");
                        sep = sep.SubString(j+1,sep.Len()-1);
                    }
                }
            }
            if (sep != _T(""))
                reg += _T("(") + sep + _T(")");
            if (reg.SubString(reg.Len()-1,reg.Len()-1) == wxString(_T("|")))
                reg = reg.SubString(0,reg.Len()-2);
            //Remplacement
            gen(titre,nom,reg);
            gen(artiste,nom,reg);
            gen(album,nom,reg);
            gen(annee,nom,reg);
            gen(piste,nom,reg);
            gen(genre,nom,reg);
            long numPiste;
            piste.ToLong(&numPiste);
            LstBox->InsertItem(h,nom);
            LstBox->SetItem(h,1,titre);
            LstBox->SetItem(h,2,artiste);
            LstBox->SetItem(h,3,album);
            LstBox->SetItem(h,4,annee);
            LstBox->SetItem(h,5,genre);
            LstBox->SetItem(h,6,piste);
            //LstBox->SetIcon(h,0);
            AncienneSel = l->getSelection(AncienneSel);
        }
        containList->Center();
        containList->Show();
        containList->Maximize();
    }
}

void MonBook::btnCopyTag(wxCommandEvent& event){
    bool isTitre = chkTitre->IsChecked();
    bool isArtiste = chkArtiste->IsChecked();
    bool isGenre = chkGenre->IsChecked();
    bool isAlbum = chkAlbum->IsChecked();
    bool isAnne = chkAnne->IsChecked();
    bool isPiste = chkPiste->IsChecked();
    bool dontCopyEmptySource = chkNoEmpty->IsChecked();
    bool isID3V2 = cb->isID3V2();
    int intCase = chooseCase->GetSelection();
    int copyOnlyEmptyTarget = radio->GetSelection();
    MaListe* curLst = cb->getCurrentList();
    MaListe* otherLst = cb->getOtherList();

    long AncienneSel = curLst->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)curLst->GetSelectedItemCount() ; i++){
       currentSel = curLst->getSelection(AncienneSel);
       wxString currentDir = curLst->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName = curLst->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
       TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
       ff->setDefaultTextEncoding(TagLib::String::UTF8);
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
       fic.setID3v2FrameFactory(ff);

       //TITLE
       if (isTitre){
           wxString titre = curLst->getSelRowText(MaListe::TITLE_COL,AncienneSel);
           if (intCase != 0) titre = ucwords(titre,intCase);
           if (!(titre == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)titre.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::TITLE_COL,titre);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::TITLE_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setTitle(s);
                   else fic.ID3v2Tag(true)->setTitle(s);
               }
           }
       }

       //ARTIST
       if (isArtiste){
           wxString artiste = curLst->getSelRowText(MaListe::ARTIST_COL,AncienneSel);
           if (intCase != 0) artiste = ucwords(artiste,intCase);
           if (!(artiste == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)artiste.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::ARTIST_COL,artiste);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::ARTIST_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setArtist(s);
                   else fic.ID3v2Tag(true)->setArtist(s);
               }
           }
       }

       //ALBUM
       if (isAlbum){
           wxString album = curLst->getSelRowText(MaListe::ALBUM_COL,AncienneSel);
           if (intCase != 0) album = ucwords(album,intCase);
           if (!(album == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)album.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::ALBUM_COL,album);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::ALBUM_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setAlbum(s);
                   else fic.ID3v2Tag(true)->setAlbum(s);
               }
           }
       }

       //GENRE
       if (isGenre){
           wxString genre = curLst->getSelRowText(MaListe::GENRE_COL,AncienneSel);
           if (intCase != 0) genre = ucwords(genre,intCase);
           if (!(genre == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)genre.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::GENRE_COL,genre);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::GENRE_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setGenre(s);
                   else fic.ID3v2Tag(true)->setGenre(s);
               }
           }
       }

       //YEAR
       if (isAnne){
           try{
               long y;
               curLst->getSelRowText(MaListe::YEAR_COL,AncienneSel).ToLong(&y);
               if (!(curLst->getSelRowText(MaListe::YEAR_COL,AncienneSel) == _T("") && dontCopyEmptySource)){
                   if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::YEAR_COL,AncienneSel) != _T(""))){
                       if (isID3V2) fic.ID3v1Tag(true)->setYear((int)y);
                       else fic.ID3v2Tag(true)->setYear((int)y);
                   }
               }
           }catch(...){}
           otherLst->SetItem(currentSel,MaListe::YEAR_COL,curLst->getSelRowText(MaListe::YEAR_COL,AncienneSel));
       }

       //TRACK
       if (isPiste){
           try{
               long t;
               curLst->getSelRowText(MaListe::TRACK_COL,AncienneSel).ToLong(&t);
               if (!(curLst->getSelRowText(MaListe::TRACK_COL,AncienneSel) == _T("") && dontCopyEmptySource)){
                   if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::TRACK_COL,AncienneSel) != _T(""))){
                       if (isID3V2) fic.ID3v1Tag(true)->setTrack((int)t);
                       else fic.ID3v2Tag(true)->setTrack((int)t);
                   }
               }
           }catch(...){}
           otherLst->SetItem(currentSel,MaListe::TRACK_COL,curLst->getSelRowText(MaListe::TRACK_COL,AncienneSel));
       }

       //SAVE
       if (isID3V2)
           fic.save(TagLib::MPEG::File::ID3v1,false);
       else
           fic.save(TagLib::MPEG::File::ID3v2,false);

       AncienneSel = currentSel;
    }
}


/*void MonBook::btnCleanID3v2Click(wxCommandEvent& event){
    if(liste->GetSelectedItemCount()==0)
        return;
    MaListe* l=(MaListe*)liste;
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<liste->GetSelectedItemCount() ; i++){
        currentSel = l->getSelection(AncienneSel);
        wxString currentDir=l->getSelRowText(8,AncienneSel);
        wxString currentName=l->getSelRowText(0,AncienneSel);
        wxString dir;
        dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
        TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);

        TagLib::String artist = fic.tag()->artist();
        TagLib::String titre = fic.tag()->title();
        TagLib::String album = fic.tag()->album();
        TagLib::String genre = fic.tag()->genre();

        wxString ar(artist.toCString(false),wxConvISO8859_1);
        wxString t(titre.toCString(false),wxConvISO8859_1);
        wxString al(album.toCString(false),wxConvISO8859_1);
        wxString g(genre.toCString(false),wxConvISO8859_1);

        ar.Replace(_T("\xFF"),_T(""));
        al.Replace(_T("\xFF"),_T(""));
        g.Replace(_T("\xFF"),_T(""));
        t.Replace(_T("\xFF"),_T(""));
        ar.Trim();
        al.Trim();
        g.Trim();
        t.Trim();

        artist = (char const*)ar.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setArtist(artist);

        titre = (char const*)t.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setTitle(titre);

        album = (char const*)al.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setAlbum(album);

        genre = (char const*)g.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setGenre(genre);

        fic.save(TagLib::MPEG::File::ID3v2,false);//On ne sauvegarde que les ID3v2
        AncienneSel = currentSel;
    }
    wxMessageDialog dlg_fin(NULL,_T("Nettoyage reussi"),_T("Traitement accompli"), wxICON_INFORMATION | wxOK);
    dlg_fin.ShowModal();
}*/


