 /**************************************************************************
 * Name:      Mon_Book.cpp                                                 *
 * Purpose:   Code for the NoteBook class                                  *
 * Author:    Jackie Team (jackie.team@gmail.com)                          *
 * Created:   2007-11-26                                                   *
 * Copyright: Jackie Team (www.musicorganizer.org)                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "components.h"
#include <fileref.h>
#include <tag.h>
#include <id3v1tag.h>
#include <id3v2tag.h>
#include <id3v2framefactory.h>
#include <mpegfile.h>


BEGIN_EVENT_TABLE(MonBook, wxNotebook)
    EVT_BUTTON(ID_SAVE,MonBook::button_click)
    EVT_BUTTON(ID_SAVE2,MonBook::button_clickV1)
    EVT_BUTTON(ID_COPIER,MonBook::btnCopyClick)
    EVT_BUTTON(ID_DEPLACER,MonBook::btnMoveClick)
    EVT_BUTTON(ID_QUICK_DEPLACER,MonBook::btnQuickMoveClick)
    EVT_BUTTON(ID_APPERCU,MonBook::btnApercuRename)
    EVT_BUTTON(MusicOrganizer::ID_ANNULER,MonBook::btnAnnulerClick)
    EVT_BUTTON(MusicOrganizer::ID_VALIDER,MonBook::btnValiderClick)
    EVT_BUTTON(ID_VALIDER_GEN,MonBook::btnValiderGenClick)
    EVT_BUTTON(ID_COPYTAG,MonBook::btnCopyTag)
    EVT_BUTTON(ID_GEN,MonBook::generateTags)
    EVT_BUTTON(ID_GEN_TRACK,MonBook::generateTracks)
    //EVT_BUTTON(ID_CLEAN,MonBook::btnCleanID3v2Click)
    EVT_TEXT(ID_COMBOORG,MonBook::textWriting)
    EVT_TEXT(ID_FIC,MonBook::textWriting2)
    EVT_TEXT(ID_ANNEE,MonBook::textWritingNumbers)
    EVT_TEXT(ID_TRACK,MonBook::textWritingNumbers2)
    EVT_MENU(ID_THREAD,MonBook::cpyMoveThreadMsg)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(TrackFrame, wxFrame)
    EVT_BUTTON(ID_PISTE_GEN,TrackFrame::genTracks)
    EVT_BUTTON(ID_CLOSE,TrackFrame::Close)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(wxModalFrame,wxFrame)
    EVT_CLOSE ( wxModalFrame::onClose )
END_EVENT_TABLE()

wxModalFrame::wxModalFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style, const wxString& name) : wxFrame(parent,id,title,pos,size,style,name){
    MakeModal(true);
}

void wxModalFrame::onClose(wxCloseEvent &event){
    MakeModal(false);
    Destroy();
}

/***********************************************************************************/

MonBook::MonBook(wxWindow* parent) : wxNotebook(parent,-1)
{
       //create and fill all tabs
        /* ***Page1*** */
    wxBoxSizer* bSizer1;
	bSizer1 = new wxBoxSizer( wxVERTICAL );
    panelPage1 = new wxPanel( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
	wxBoxSizer* bSizer5;
	bSizer5 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticBoxSizer* sbSizer15;
        //ID3V1
	sbSizer15 = new wxStaticBoxSizer( new wxStaticBox( panelPage1, wxID_ANY, _T("ID3v1") ), wxVERTICAL );

	wxBoxSizer* bSizer3;
	bSizer3 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText1;
	m_staticText1 = new wxStaticText( panelPage1, wxID_ANY, _("Title"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText1->Wrap( -1 );
	bSizer3->Add( m_staticText1, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboTitre2 = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer3->Add( comboTitre2, 0, wxALL|wxEXPAND, 5 );

	sbSizer15->Add( bSizer3, 0, wxALIGN_CENTER_VERTICAL|wxEXPAND, 0 );

	wxBoxSizer* bSizer4;
	bSizer4 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText3;
	m_staticText3 = new wxStaticText( panelPage1, wxID_ANY, _("Artist"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText3->Wrap( -1 );
	bSizer4->Add( m_staticText3, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboInterprete2 = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer4->Add( comboInterprete2, 0, wxALL|wxEXPAND, 5 );

	sbSizer15->Add( bSizer4, 0, wxEXPAND, 0 );

	wxBoxSizer* bSizer51;
	bSizer51 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText2;
	m_staticText2 = new wxStaticText( panelPage1, wxID_ANY, _("Album"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText2->Wrap( -1 );
	bSizer51->Add( m_staticText2, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboAlbum2 = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer51->Add( comboAlbum2, 0, wxALL|wxEXPAND, 5 );

	sbSizer15->Add( bSizer51, 0, wxEXPAND, 0 );

	wxBoxSizer* bSizer7;
	bSizer7 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText5;
	m_staticText5 = new wxStaticText( panelPage1, wxID_ANY, _("Genre"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText5->Wrap( -1 );
	bSizer7->Add( m_staticText5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboGenre2 = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer7->Add( comboGenre2, 0, wxALL|wxEXPAND, 5 );

	sbSizer15->Add( bSizer7, 0, wxEXPAND, 0 );

	wxBoxSizer* bSizer6;
	bSizer6 = new wxBoxSizer( wxHORIZONTAL );

	wxBoxSizer* bSizer9;
	bSizer9 = new wxBoxSizer( wxVERTICAL );

	wxBoxSizer* bSizer11;
	bSizer11 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText4;
	m_staticText4 = new wxStaticText( panelPage1, wxID_ANY, _("Year"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText4->Wrap( -1 );
	bSizer11->Add( m_staticText4, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboAnne2 = new ComboBox(this, panelPage1, ID_ANNEE, wxEmptyString, wxDefaultPosition, wxSize( 140,-1 ),wxArrayString(),wxCB_SORT);
	bSizer11->Add( comboAnne2, 0, wxALL|wxEXPAND, 5 );

	bSizer9->Add( bSizer11, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer12;
	bSizer12 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText6;
	m_staticText6 = new wxStaticText( panelPage1, wxID_ANY, _("Track"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText6->Wrap( -1 );
	bSizer12->Add( m_staticText6, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboPiste2 = new ComboBox(this, panelPage1, ID_TRACK, wxEmptyString, wxDefaultPosition, wxSize( 140,-1 ),wxArrayString(),wxCB_SORT);
	bSizer12->Add( comboPiste2, 0, wxALL|wxEXPAND, 5 );

	bSizer9->Add( bSizer12, 1, wxEXPAND, 5 );

	bSizer6->Add( bSizer9, 0, wxEXPAND, 5 );

	wxBoxSizer* bSizer10;
	bSizer10 = new wxBoxSizer( wxHORIZONTAL );

	wxImage* disq=new wxImage();
    disq->AddHandler(new wxPNGHandler());
#ifdef __WXMAC__
    if(wxFileExists( _T ( "disquette.png" ) ))
       disq->LoadFile ( _T ( "disquette.png" ) );
    else
       disq->LoadFile ( MusicOrganizer::stFindResourceFile ( "disquette","png" ));
#else
    disq->LoadFile(_T("disquette.png"));
#endif
	button_save2 = new wxBitmapButton( panelPage1, ID_SAVE2, wxBitmap(*disq), wxDefaultPosition, wxSize( 50,44 ), wxBU_AUTODRAW );
	bSizer10->Add( button_save2, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	bSizer6->Add( bSizer10, 0, wxEXPAND, 5 );

	sbSizer15->Add( bSizer6, 0, wxEXPAND, 0 );

	bSizer5->Add( sbSizer15, 0, wxALL|wxEXPAND, 5 );

	wxStaticBoxSizer* sbSizer151;
        //ID3V2
	sbSizer151 = new wxStaticBoxSizer( new wxStaticBox( panelPage1, wxID_ANY, _T("ID3v2") ), wxVERTICAL );

	wxBoxSizer* bSizer31;
	bSizer31 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText11;
	m_staticText11 = new wxStaticText( panelPage1, wxID_ANY, _("Title"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText11->Wrap( -1 );
	bSizer31->Add( m_staticText11, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboTitre = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer31->Add( comboTitre, 0, wxALL|wxEXPAND, 5 );

	sbSizer151->Add( bSizer31, 0, wxALIGN_CENTER_VERTICAL|wxEXPAND, 0 );

	wxBoxSizer* bSizer41;
	bSizer41 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText31;
	m_staticText31 = new wxStaticText( panelPage1, wxID_ANY, _("Artist"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText31->Wrap( -1 );
	bSizer41->Add( m_staticText31, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboInterprete = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer41->Add( comboInterprete, 0, wxALL|wxEXPAND, 5 );

	sbSizer151->Add( bSizer41, 0, wxEXPAND, 0 );

	wxBoxSizer* bSizer511;
	bSizer511 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText21;
	m_staticText21 = new wxStaticText( panelPage1, wxID_ANY, _("Album"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText21->Wrap( -1 );
	bSizer511->Add( m_staticText21, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboAlbum = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer511->Add( comboAlbum, 0, wxALL|wxEXPAND, 5 );

	sbSizer151->Add( bSizer511, 0, wxEXPAND, 0 );

	wxBoxSizer* bSizer71;
	bSizer71 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText51;
	m_staticText51 = new wxStaticText( panelPage1, wxID_ANY, _("Genre"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText51->Wrap( -1 );
	bSizer71->Add( m_staticText51, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboGenre = new ComboBox(this, panelPage1, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 200,-1 ),wxArrayString(),wxCB_SORT);
	bSizer71->Add( comboGenre, 0, wxALL|wxEXPAND, 5 );

	sbSizer151->Add( bSizer71, 0, wxEXPAND, 0 );

	wxBoxSizer* bSizer61;
	bSizer61 = new wxBoxSizer( wxHORIZONTAL );

	wxBoxSizer* bSizer91;
	bSizer91 = new wxBoxSizer( wxVERTICAL );

	wxBoxSizer* bSizer111;
	bSizer111 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText41;
	m_staticText41 = new wxStaticText( panelPage1, wxID_ANY, _("Year"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText41->Wrap( -1 );
	bSizer111->Add( m_staticText41, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboAnne = new ComboBox(this, panelPage1, ID_ANNEE, wxEmptyString, wxDefaultPosition, wxSize( 140,-1 ),wxArrayString(),wxCB_SORT);
	bSizer111->Add( comboAnne, 0, wxALL|wxEXPAND, 5 );

	bSizer91->Add( bSizer111, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer121;
	bSizer121 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText61;
	m_staticText61 = new wxStaticText( panelPage1, wxID_ANY, _("Track"), wxDefaultPosition, wxSize( 40,-1 ), 0 );
	m_staticText61->Wrap( -1 );
	bSizer121->Add( m_staticText61, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboPiste = new ComboBox(this, panelPage1, ID_TRACK, wxEmptyString, wxDefaultPosition, wxSize( 140,-1 ),wxArrayString(),wxCB_SORT);
	bSizer121->Add( comboPiste, 0, wxALL|wxEXPAND, 5 );

	bSizer91->Add( bSizer121, 1, wxEXPAND, 5 );

	bSizer61->Add( bSizer91, 0, wxEXPAND, 5 );

	wxBoxSizer* bSizer101;
	bSizer101 = new wxBoxSizer( wxHORIZONTAL );
	bSizer101 = new wxBoxSizer( wxHORIZONTAL );

	button_save = new wxBitmapButton( panelPage1, ID_SAVE, wxBitmap( *disq), wxDefaultPosition, wxSize( 50,44 ), wxBU_AUTODRAW );
	bSizer101->Add( button_save, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	bSizer61->Add( bSizer101, 0, wxEXPAND, 5 );

	sbSizer151->Add( bSizer61, 0, wxEXPAND, 0 );

	bSizer5->Add( sbSizer151, 1, wxALL|wxEXPAND, 5 );

	panelPage1->SetSizer( bSizer5 );
	panelPage1->Layout();
	bSizer5->Fit( panelPage1 );
	this->AddPage( panelPage1, _("Tags"), true );

        /* ***Page2*** */
	panelPage2 = new wxPanel( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
	wxBoxSizer* bSizer21;
	bSizer21 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticBoxSizer* sbSizer3;
	sbSizer3 = new wxStaticBoxSizer( new wxStaticBox( panelPage2, wxID_ANY, _("Organization") ), wxVERTICAL );

	wxStaticText* m_staticText13;
	m_staticText13 = new wxStaticText( panelPage2, wxID_ANY, _("File organization's description:"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText13->Wrap( -1 );
	sbSizer3->Add( m_staticText13, 0, wxALL, 5 );

	comboOrg = new ComboBox(this, panelPage2, ID_COMBOORG, wxEmptyString, wxDefaultPosition, wxSize( 400,-1 ),wxArrayString(),wxCB_SORT);
	comboOrg->Append( _T("%1/%2") );
	comboOrg->Append( _T("%4/%1") );
	comboOrg->Append( _T("%4/%1/%2") );
	comboOrg->Append( _T("%3/%4") );
	comboOrg->Append( _T("%3/%4/%1") );
	comboOrg->Append( _T("%3/%4/%1/%2") );
	sbSizer3->Add( comboOrg, 0, wxALL|wxEXPAND, 5 );

	wxBoxSizer* bSizer23;
	bSizer23 = new wxBoxSizer( wxHORIZONTAL );

	wxBoxSizer* bSizer24;
	bSizer24 = new wxBoxSizer( wxVERTICAL );

	wxStaticText* m_staticText14;
	m_staticText14 = new wxStaticText( panelPage2, wxID_ANY, _("Keyboarding preview:"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText14->Wrap( -1 );
	bSizer24->Add( m_staticText14, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

	DescrSaisie = new wxTextCtrl( panelPage2, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 280,-1 ), wxTE_MULTILINE|wxST_NO_AUTORESIZE|wxALIGN_CENTRE/*|wxTE_BESTWRAP*/|wxTE_READONLY );
	DescrSaisie->SetBackgroundColour( wxSystemSettings::GetColour( wxSYS_COLOUR_3DLIGHT ) );

	bSizer24->Add( DescrSaisie, 1, wxALIGN_CENTER|wxALL|wxEXPAND, 5 );

	bSizer23->Add( bSizer24, 0, wxEXPAND, 5 );

	wxBoxSizer* bSizer25;
	bSizer25 = new wxBoxSizer( wxVERTICAL );


	bSizer25->Add( 0, 25, 1, wxEXPAND, 5 );

	btnCopier = new wxButton( panelPage2, ID_COPIER, _("Copy to..."), wxDefaultPosition, wxSize( 125,30 ), 0 );
	bSizer25->Add( btnCopier, 0, wxALL, 5 );

	btnDeplacer = new wxButton( panelPage2, ID_DEPLACER, _("Move to..."), wxDefaultPosition, wxSize( 125,30 ), 0 );
	bSizer25->Add( btnDeplacer, 0, wxALL, 5 );

	btnQuickDeplacer = new wxButton( panelPage2, ID_QUICK_DEPLACER, _("Quick move"), wxDefaultPosition, wxSize( 125,30 ), 0 );
	bSizer25->Add( btnQuickDeplacer, 0, wxALL, 5 );

	bSizer23->Add( bSizer25, 0, wxALL, 1 );

	sbSizer3->Add( bSizer23, 1, wxEXPAND, 5 );

	bSizer21->Add( sbSizer3, 0, wxALL|wxEXPAND, 5 );

	wxStaticBoxSizer* sbSizer4;
	sbSizer4 = new wxStaticBoxSizer( new wxStaticBox( panelPage2, wxID_ANY, _("Caption") ), wxVERTICAL );

	wxStaticText* m_staticText15;
	m_staticText15 = new wxStaticText( panelPage2, wxID_ANY, _("%1 : Artist\n%2 : Album\n%3 : Year\n%4 : Genre"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText15->Wrap( -1 );
	quickDir  = new wxStaticText( panelPage2, wxID_ANY, _("Current quick directory : "), wxDefaultPosition, wxDefaultSize, 0 );
	quickDir->SetLabel(_("Current quick directory : ") + OptionsHandler::getOption(_T("/notebook/tab_2/quickmove"),wxString(_T(""))));
	quickDir->Wrap( -1 );

	sbSizer4->Add( m_staticText15, 0, wxALL, 5 );
	sbSizer4->Add(0,0,1);
	sbSizer4->Add( quickDir, 0, wxALL, 5 );

	bSizer21->Add( sbSizer4, 1, wxALL|wxEXPAND, 5 );

	panelPage2->SetSizer( bSizer21 );
	panelPage2->Layout();
	bSizer21->Fit( panelPage2 );
	this->AddPage( panelPage2, _("Organize"), false );

        /* ***Page3*** */
	panelPage3 = new wxPanel( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
	wxBoxSizer* bSizer211;
	bSizer211 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticBoxSizer* sbSizer31;
	sbSizer31 = new wxStaticBoxSizer( new wxStaticBox( panelPage3, wxID_ANY, _("Rename") ), wxVERTICAL );

	wxStaticText* m_staticText131;
	m_staticText131 = new wxStaticText( panelPage3, wxID_ANY, _("Files' name"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText131->Wrap( -1 );
	sbSizer31->Add( m_staticText131, 0, wxALL, 5 );

	comboNomFic = new ComboBox(this, panelPage3, ID_FIC, wxEmptyString, wxDefaultPosition, wxSize( 400,-1 ),wxArrayString(),wxCB_SORT);
	comboNomFic->Append( _T("%2 - %1") );
	comboNomFic->Append( _T("%5 - %1") );
	sbSizer31->Add( comboNomFic, 0, wxALL|wxEXPAND, 5 );

	wxBoxSizer* bSizer231;
	bSizer231 = new wxBoxSizer( wxHORIZONTAL );

	wxBoxSizer* bSizer241;
	bSizer241 = new wxBoxSizer( wxVERTICAL );

	wxStaticText* m_staticText141;
	m_staticText141 = new wxStaticText( panelPage3, wxID_ANY, _("Keyboarding preview:"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText141->Wrap( -1 );
	bSizer241->Add( m_staticText141, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

	DescrSaisie2 = new wxTextCtrl( panelPage3, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 280,-1 ), wxTE_MULTILINE|wxST_NO_AUTORESIZE|wxALIGN_CENTRE/*|wxTE_BESTWRAP*/|wxTE_READONLY );
	DescrSaisie2->SetBackgroundColour( wxSystemSettings::GetColour( wxSYS_COLOUR_3DLIGHT ) );

	bSizer241->Add( DescrSaisie2, 1, wxALIGN_CENTER|wxALL|wxEXPAND, 5 );

	bSizer231->Add( bSizer241, 0, wxEXPAND, 5 );

	wxBoxSizer* bSizer251;
	bSizer251 = new wxBoxSizer( wxVERTICAL );


	bSizer251->Add( 0, 24, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer36;
	bSizer36 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText22;
	m_staticText22 = new wxStaticText( panelPage3, wxID_ANY, _("Track format:"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText22->Wrap( -1 );
	bSizer36->Add( m_staticText22, 1, wxALIGN_CENTER_VERTICAL, 5 );

	comboFormatPiste = new wxComboBox( panelPage3, ID_FIC, _("00"), wxDefaultPosition, wxDefaultSize, 0, NULL, 0 );
	comboFormatPiste->Append( _T("0") );
	comboFormatPiste->Append( _T("00") );
	comboFormatPiste->Append( _T("000") );
	bSizer36->Add( comboFormatPiste, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	bSizer251->Add( bSizer36, 0, wxALIGN_RIGHT|wxALL|wxEXPAND, 5 );

	btnApercu = new wxButton( panelPage3, ID_APPERCU, _("Preview"), wxDefaultPosition, wxSize( 125,30 ), 0 );
	bSizer251->Add( btnApercu, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5 );

	bSizer231->Add( bSizer251, 0, wxALL, 1 );

	sbSizer31->Add( bSizer231, 1, wxEXPAND, 5 );

	bSizer211->Add( sbSizer31, 0, wxALL|wxEXPAND, 5 );

	wxStaticBoxSizer* sbSizer41;
	sbSizer41 = new wxStaticBoxSizer( new wxStaticBox( panelPage3, wxID_ANY, _("Caption") ), wxVERTICAL );

	wxStaticText* m_staticText151;
	m_staticText151 = new wxStaticText( panelPage3, wxID_ANY, _("%1 : Title \n%2 : Artist \n%3 : Album \n%4 : Year \n%5 : Track \n%6 : Genre"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText151->Wrap( -1 );
	sbSizer41->Add( m_staticText151, 0, wxALL, 5 );

	bSizer211->Add( sbSizer41, 1, wxALL|wxEXPAND, 5 );

	panelPage3->SetSizer( bSizer211 );
	panelPage3->Layout();
	bSizer211->Fit( panelPage3 );
	this->AddPage( panelPage3, _("Rename"), false );

        /* ***Page4*** */
	panelPage4 = new wxPanel( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
	wxBoxSizer* bSizer37;
	bSizer37 = new wxBoxSizer( wxVERTICAL );

	wxStaticBoxSizer* sbSizer9;
	sbSizer9 = new wxStaticBoxSizer( new wxStaticBox( panelPage4, wxID_ANY, _("Copy") ), wxVERTICAL );

	wxStaticBoxSizer* sbSizer152;
	sbSizer152 = new wxStaticBoxSizer( new wxStaticBox( panelPage4, wxID_ANY, _("Tags to copy") ), wxHORIZONTAL );

	chkTitre = new wxCheckBox( panelPage4, wxID_ANY, _("Title"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer152->Add( chkTitre, 0, wxALL, 5 );

	chkAlbum = new wxCheckBox( panelPage4, wxID_ANY, _("Album"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer152->Add( chkAlbum, 0, wxALL, 5 );

	chkArtiste = new wxCheckBox( panelPage4, wxID_ANY, _("Artist"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer152->Add( chkArtiste, 0, wxALL, 5 );

	chkGenre = new wxCheckBox( panelPage4, wxID_ANY, _("Genre"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer152->Add( chkGenre, 0, wxALL, 5 );

	chkAnne = new wxCheckBox( panelPage4, wxID_ANY, _("Year"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer152->Add( chkAnne, 0, wxALL, 5 );

	chkPiste = new wxCheckBox( panelPage4, wxID_ANY, _("Track"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer152->Add( chkPiste, 0, wxALL, 5 );

	sbSizer9->Add( sbSizer152, 0, wxALL, 5 );

	wxBoxSizer* bSizer40;
	bSizer40 = new wxBoxSizer( wxHORIZONTAL );

	wxString radioChoices[] = { _("Replace all fields"), _("Replace only blank fields") };
	int radioNChoices = sizeof( radioChoices ) / sizeof( wxString );
	radio = new wxRadioBox( panelPage4, wxID_ANY, _("Replacement"), wxDefaultPosition, wxDefaultSize, radioNChoices, radioChoices, 1, wxRA_SPECIFY_COLS );
	radio->SetSelection( 0 );
	bSizer40->Add( radio, 0, wxALL|wxEXPAND, 5 );

	wxStaticBoxSizer* sbSizer14;
	sbSizer14 = new wxStaticBoxSizer( new wxStaticBox( panelPage4, wxID_ANY, _("Case") ), wxHORIZONTAL );

	wxString chooseCaseChoices[] = { _("No change"), _("Make lower"), _("Make UPPER"), _("Capitalize First Letters") };
	int chooseCaseNChoices = sizeof( chooseCaseChoices ) / sizeof( wxString );
	chooseCase = new wxChoice( panelPage4, wxID_ANY, wxDefaultPosition, wxDefaultSize, chooseCaseNChoices, chooseCaseChoices, 0 );
	chooseCase->SetSelection( 0 );
	sbSizer14->Add( chooseCase, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	bSizer40->Add( sbSizer14, 0, wxALL|wxEXPAND, 5 );

	sbSizer9->Add( bSizer40, 0, wxEXPAND, 5 );

	chkNoEmpty = new wxCheckBox( panelPage4, wxID_ANY, _("Copy only if source is not blank"), wxDefaultPosition, wxDefaultSize, 0 );

	sbSizer9->Add( chkNoEmpty, 0, wxALL, 5 );

	wxGridSizer* gSizer1;
	gSizer1 = new wxGridSizer( 1, 1, 0, 0 );

	btnCopierIdv = new wxButton( panelPage4, ID_COPYTAG, _("Copy"), wxDefaultPosition, wxDefaultSize, 0 );
	gSizer1->Add( btnCopierIdv, 0, wxALIGN_BOTTOM|wxALIGN_RIGHT|wxALL, 5 );

	sbSizer9->Add( gSizer1, 1, wxEXPAND, 5 );

	bSizer37->Add( sbSizer9, 1, wxALL|wxEXPAND, 5 );

	panelPage4->SetSizer( bSizer37 );
	panelPage4->Layout();
	bSizer37->Fit( panelPage4 );
	this->AddPage( panelPage4, _T("ID3V2 -> ID3V1"), false );

        /* ***Page5*** */
	panelPage5 = new wxPanel( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
	wxBoxSizer* bSizer43;
	bSizer43 = new wxBoxSizer( wxVERTICAL );

	wxStaticBoxSizer* sbSizer16;
	sbSizer16 = new wxStaticBoxSizer( new wxStaticBox( panelPage5, wxID_ANY, _("Tags") ), wxVERTICAL );

	wxGridSizer* gSizer6;
	gSizer6 = new wxGridSizer( 2, 3, 0, 0 );

	wxBoxSizer* bSizer46;
	bSizer46 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText23;
	m_staticText23 = new wxStaticText( panelPage5, wxID_ANY, _("Title"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText23->Wrap( -1 );
	bSizer46->Add( m_staticText23, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	txtTitreGen = new wxTextCtrl( panelPage5, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 145,-1 ), 0 );
	bSizer46->Add( txtTitreGen, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	gSizer6->Add( bSizer46, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer461;
	bSizer461 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText231;
	m_staticText231 = new wxStaticText( panelPage5, wxID_ANY, _("Artist"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText231->Wrap( -1 );
	bSizer461->Add( m_staticText231, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	txtInterpreteGen = new wxTextCtrl( panelPage5, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 145,-1 ), 0 );
	bSizer461->Add( txtInterpreteGen, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	gSizer6->Add( bSizer461, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer462;
	bSizer462 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText232;
	m_staticText232 = new wxStaticText( panelPage5, wxID_ANY, _("Year"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText232->Wrap( -1 );
	bSizer462->Add( m_staticText232, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboAnneGen = new ComboBox(this, panelPage5, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 145,-1 ),wxArrayString(),wxCB_SORT);
	bSizer462->Add( comboAnneGen, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	gSizer6->Add( bSizer462, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer463;
	bSizer463 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText233;
	m_staticText233 = new wxStaticText( panelPage5, wxID_ANY, _("Album"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText233->Wrap( -1 );
	bSizer463->Add( m_staticText233, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	txtAlbumGen = new wxTextCtrl( panelPage5, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 145,-1 ), 0 );
	bSizer463->Add( txtAlbumGen, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	gSizer6->Add( bSizer463, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer464;
	bSizer464 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText234;
	m_staticText234 = new wxStaticText( panelPage5, wxID_ANY, _("Genre"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText234->Wrap( -1 );
	bSizer464->Add( m_staticText234, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	comboGenreGen = new ComboBox(this, panelPage5, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 145,-1 ),wxArrayString(),wxCB_SORT);
	bSizer464->Add( comboGenreGen, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	gSizer6->Add( bSizer464, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer465;
	bSizer465 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText235;
	m_staticText235 = new wxStaticText( panelPage5, wxID_ANY, _("Track"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText235->Wrap( -1 );
	bSizer465->Add( m_staticText235, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	txtPisteGen = new wxTextCtrl( panelPage5, wxID_ANY, wxEmptyString, wxDefaultPosition, wxSize( 50,-1 ), 0 );
	bSizer465->Add( txtPisteGen, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	btnAutoTrack = new wxButton( panelPage5, ID_GEN_TRACK, _("Auto track"), wxDefaultPosition, wxSize( 90,-1 ), 0 );
	bSizer465->Add( btnAutoTrack, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT, 5 );

	gSizer6->Add( bSizer465, 1, wxEXPAND, 5 );

	sbSizer16->Add( gSizer6, 0, 0, 5 );

	wxBoxSizer* bSizer75;
	bSizer75 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticBoxSizer* sbSizer17;
	sbSizer17 = new wxStaticBoxSizer( new wxStaticBox( panelPage5, wxID_ANY, _("Options") ), wxHORIZONTAL );

	wxString radioGenChoices[] = { _("Replace all fields"), _("Replace only blank fields") };
	int radioGenNChoices = sizeof( radioGenChoices ) / sizeof( wxString );
	radioGen = new wxRadioBox( panelPage5, wxID_ANY, _("Replacement"), wxDefaultPosition, wxDefaultSize, radioGenNChoices, radioGenChoices, 1, wxRA_SPECIFY_COLS );
	radioGen->SetSelection( 0 );
	sbSizer17->Add( radioGen, 0, wxALL|wxEXPAND, 5 );

	wxBoxSizer* bSizer74;
	bSizer74 = new wxBoxSizer( wxVERTICAL );

	chkNoEmptyGen = new wxCheckBox( panelPage5, wxID_ANY, _("Copy only if source is not blank"), wxDefaultPosition, wxDefaultSize, 0 );

	bSizer74->Add( chkNoEmptyGen, 0, wxALL, 5 );

	chkGenAll = new wxCheckBox( panelPage5, wxID_ANY, _("Generate ID3V1 and ID3V2"), wxDefaultPosition, wxDefaultSize, 0 );

	bSizer74->Add( chkGenAll, 0, wxALL, 5 );

	wxBoxSizer* bSizer76;
	bSizer76 = new wxBoxSizer( wxHORIZONTAL );

	wxStaticText* m_staticText32;
	m_staticText32 = new wxStaticText( panelPage5, wxID_ANY, _("Separators"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText32->Wrap( -1 );
	bSizer76->Add( m_staticText32, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	txtSeparator = new wxTextCtrl( panelPage5, wxID_ANY, _("_-_:"), wxDefaultPosition, wxDefaultSize, 0 );
	bSizer76->Add( txtSeparator, 1, wxALL, 5 );

	bSizer74->Add( bSizer76, 1, wxEXPAND, 5 );

	sbSizer17->Add( bSizer74, 1, wxEXPAND, 5 );

	bSizer75->Add( sbSizer17, 0, wxALL|wxEXPAND, 5 );

	wxStaticBoxSizer* sbSizer20;
	sbSizer20 = new wxStaticBoxSizer( new wxStaticBox( panelPage5, wxID_ANY, _("Caption") ), wxVERTICAL );

	wxStaticText* m_staticText311;
	m_staticText311 = new wxStaticText( panelPage5, wxID_ANY, _("%1 - %99 : Words \nbetween separators \nSeparators : Values \nseparated by ':' \n(without quotes)"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText311->Wrap( -1 );


	sbSizer20->Add( m_staticText311, 0, wxALL, 4 );

	bSizer75->Add( sbSizer20, 0, wxALL|wxEXPAND, 5 );

	sbSizer16->Add( bSizer75, 0, wxEXPAND, 5 );

	wxGridSizer* gSizer11;
	gSizer11 = new wxGridSizer( 1, 1, 0, 0 );

	btnGen = new wxButton( panelPage5, ID_GEN, _("Generate !"), wxDefaultPosition, wxDefaultSize, 0 );
	gSizer11->Add( btnGen, 0, wxALIGN_BOTTOM|wxALIGN_RIGHT|wxALL, 5 );

	sbSizer16->Add( gSizer11, 1, wxEXPAND, 5 );

	bSizer43->Add( sbSizer16, 1, wxALL|wxEXPAND, 5 );

	panelPage5->SetSizer( bSizer43 );
	panelPage5->Layout();
	bSizer43->Fit( panelPage5 );
	this->AddPage( panelPage5, _("Generate"), false );

	bSizer1->Add( this, 1, wxEXPAND | wxALL, 5 );

	this->SetSizer( bSizer1 );
	this->Layout();

        //On initialise les genres et les annÃ©es
        for (int i=0 ; i<=125 ; i++){
            comboGenre->Append(GENRES[i]);
            comboGenre2->Append(GENRES[i]);
            comboGenreGen->Append(GENRES[i]);
        }
        for (int i=0 ; i<=201 ; i++){
            comboAnne->Append(wxString::Format(_T("%d"),1850 +i));
            comboAnne2->Append(wxString::Format(_T("%d"),1850 +i));
            comboAnneGen->Append(wxString::Format(_T("%d"),1850 +i));
        }
        restoreTabs();


}

/* ******************************************************************************* */

void MonBook::setChoicebook(MonChoicebook* c){
    cb=c;
}

/* ******************************************************************************* */

void MonBook::setArbo(MonArbo* a){
    arbo=a;
}

/* ******************************************************************************* */

void MonBook::button_click(wxCommandEvent& event){
    //save ID3V2 tags
    if(cb->getMListeV2()->GetSelectedItemCount()==0)
        return;
    //As the editing can't be undone the user is warned
    wxMessageDialog dlg_info(NULL,_("Save changes?"),_("Warning!"), wxICON_EXCLAMATION | wxYES_NO);
    int res=dlg_info.ShowModal();
    dlg_info.Destroy();

    if (res==wxID_NO)
      return ;
    MaListe* l=cb->getMListeV2();
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)l->GetSelectedItemCount() ; i++){//for each selected items
       currentSel= l->getSelection(AncienneSel);
       wxString currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());

       //use taglib to write only ID3V2 tags
       TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
       ff->setDefaultTextEncoding(TagLib::String::UTF8);
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
       fic.setID3v2FrameFactory(ff);


        if(comboTitre->GetValue()!=_("<Title>") ){//title tag must be written
            TagLib::String s((char const*)comboTitre->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboTitre->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setTitle(TagLib::String::null);
            else
                fic.ID3v2Tag(true)->setTitle(s);
            l->SetItem(currentSel,MaListe::TITLE_COL,comboTitre->GetValue());
        }

        if(comboInterprete->GetValue()!=_("<Artist>") ){//artist tag must be written
            TagLib::String s((char const*)comboInterprete->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboInterprete->GetValue()==_T("")){
                //wxMessageBox(_T("aaa"));
                fic.ID3v2Tag(true)->setArtist(TagLib::String::null);
            }else
                fic.ID3v2Tag(true)->setArtist(s);
            l->SetItem(currentSel,MaListe::ARTIST_COL,comboInterprete->GetValue());
        }

        if(comboAlbum->GetValue()!=_("<Album>") ){//album tag must be written
            TagLib::String s((char const*)comboAlbum->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboAlbum->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setAlbum(TagLib::String::null);
            else
                fic.ID3v2Tag(true)->setAlbum(s);
            l->SetItem(currentSel,MaListe::ALBUM_COL,comboAlbum->GetValue());
        }

        if(comboAnne->GetValue()!=_("<Year>") ){//year tag must be written
            long y=0;
            if(comboAnne->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setYear(0);
            else{
                try{
                    comboAnne->GetValue().ToLong(&y);
                    fic.ID3v2Tag(true)->setYear((int)y);
                }catch(...){
                }
            }
            if(y==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::YEAR_COL,comboAnne->GetValue());
        }

        if(comboPiste->GetValue()!=_("<Track>") ){//track tag must be written
            long t=0;
            if(comboPiste->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setTrack(0);
            else{
                try{
                    comboPiste->GetValue().ToLong(&t);
                    fic.ID3v2Tag(true)->setTrack((int)t);
                }catch(...){
                }
            }
            if(t==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::TRACK_COL,comboPiste->GetValue());
        }

        if(comboGenre->GetValue()!=_("<Genre>") ){//genre tag must be written
            TagLib::String s((char const*)comboGenre->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboGenre->GetValue()==_T(""))
                fic.ID3v2Tag(true)->setGenre(TagLib::String::null);
            else
                fic.ID3v2Tag(true)->setGenre(s);
            l->SetItem(currentSel,MaListe::GENRE_COL,comboGenre->GetValue());
        }

        fic.save(TagLib::MPEG::File::ID3v2,false);//Only ID3v2 will be saved
        AncienneSel = currentSel;

    }

}

/* ******************************************************************************* */

void MonBook::button_clickV1(wxCommandEvent& event){
    //save ID3V1 tags
    if(cb->getMListeV2()->GetSelectedItemCount()==0)
        return;
    //As the editing can't be undone the user is warned
    wxMessageDialog dlg_info(NULL,_("Save changes?"),_("Warning!"), wxICON_EXCLAMATION | wxYES_NO);
    int res=dlg_info.ShowModal();
    dlg_info.Destroy();

    if (res==wxID_NO)
      return ;
    MaListe* l=cb->getMListeV1();
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)l->GetSelectedItemCount() ; i++){//for each selected files
       currentSel = l->getSelection(AncienneSel);
       wxString currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());

       //use taglib to save only ID3V1 tags
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);

        if(comboTitre2->GetValue()!=_("<Title>") ){//title tag must be written
            TagLib::String t((char const*)comboTitre2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboTitre2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setTitle(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setTitle(t);
            l->SetItem(currentSel,MaListe::TITLE_COL,comboTitre2->GetValue());
        }

        if(comboInterprete2->GetValue()!=_("<Artist>") ){//artist tag must be written
            TagLib::String s((char const*)comboInterprete2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboInterprete2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setArtist(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setArtist(s);
            l->SetItem(currentSel,MaListe::ARTIST_COL,comboInterprete2->GetValue());
        }

        if(comboAlbum2->GetValue()!=_("<Album>") ){//album tag must be written
            TagLib::String s((char const*)comboAlbum2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboAlbum2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setAlbum(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setAlbum(s);
            l->SetItem(currentSel,MaListe::ALBUM_COL,comboAlbum2->GetValue());
        }


        if(comboAnne2->GetValue()!=_("<Year>") ){//year tag must be written
            long y=0;
            if(comboAnne2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setYear(0);
            else{
                try{
                    comboAnne2->GetValue().ToLong(&y);
                    fic.ID3v1Tag(true)->setYear((int)y);
                }catch(...){
                }
            }
            if(y==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::YEAR_COL,comboAnne2->GetValue());
        }


        if(comboPiste2->GetValue()!=_("<Track>") ){//track tag must be written
            long t=0;
            if(comboPiste2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setTrack(0);
            else{
                try{
                    comboPiste2->GetValue().ToLong(&t);
                    fic.ID3v1Tag(true)->setTrack((int)t);
                }catch(...){
                }
            }
            if(t==0)
                l->SetItem(currentSel,MaListe::TRACK_COL,_T(""));
            else
                l->SetItem(currentSel,MaListe::TRACK_COL,comboPiste2->GetValue());
        }


        if(comboGenre2->GetValue()!=_("<Genre>") ){//genre tag must be written
            TagLib::String s((char const*)comboGenre2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            if(comboGenre2->GetValue()==_T(""))
                fic.ID3v1Tag(true)->setGenre(TagLib::String::null);
            else
                fic.ID3v1Tag(true)->setGenre(s);
            l->SetItem(currentSel,MaListe::GENRE_COL,comboGenre2->GetValue());
        }

        fic.save(TagLib::MPEG::File::ID3v1,false);//On ne sauvegarde que les ID3v1
        AncienneSel = currentSel;

    }

}

/* ******************************************************************************* */

void MonBook::cleanStr(wxString& str,wxString& replace){

    wxRegEx eexp(wxT("[\xE8\xE9\xEA\xEB]"));//e with accent or dieresis or circumflex
    wxRegEx euexp(wxT("[\xC8\xC9\xCA\xCB]"));//E with accent or dieresis or circumflex
    wxRegEx aexp(wxT("[\xE0\xE1\xE2\xE3\xE4\xE5]"));//a with accent or dieresis or circumflex
    wxRegEx auexp(wxT("[\xC0\xC1\xC2\xC3\xC4\xC5]"));//A with accent or dieresis or circumflex
    wxRegEx iexp(wxT("[\xEC\xED\xEE\xEF]"));//i with accent or dieresis or circumflex
    wxRegEx iuexp(wxT("[\xCC\xCD\xCE\xCF]"));//I with accent or dieresis or circumflex
    wxRegEx oexp(wxT("[\xF2\xF3\xF4\xF5\xF6]"));//o with accent or dieresis or circumflex
    wxRegEx ouexp(wxT("[\xD2\xD3\xD4\xD5\xD6]"));//O with accent or dieresis or circumflex
    wxRegEx uexp(wxT("[\xF9\xFA\xFB\xFC]"));//u with accent or dieresis or circumflex
    wxRegEx uuexp(wxT("[\xD9\xDA\xDB\xDC]"));//U with accent or dieresis or circumflex
    wxRegEx invalid_chars(wxT("[\\:*?\"<>|]"));

    eexp.Replace(&str,wxString(_T("e")),0);
    euexp.Replace(&str,wxString(_T("E")),0);wxRegEx exp(wxT("%([1-9][0-9])"));
    aexp.Replace(&str,wxString(_T("a")),0);
    auexp.Replace(&str,wxString(_T("A")),0);
    iexp.Replace(&str,wxString(_T("i")),0);
    iuexp.Replace(&str,wxString(_T("I")),0);
    oexp.Replace(&str,wxString(_T("o")),0);
    ouexp.Replace(&str,wxString(_T("O")),0);
    uexp.Replace(&str,wxString(_T("u")),0);
    uuexp.Replace(&str,wxString(_T("U")),0);
    str.Replace(wxT("\xE7"),wxT("c"));
    str.Replace(wxT("\xC7"),wxT("C"));
    invalid_chars.Replace(&str,replace,0);
    str.Replace(_T("\0"),_T(""));


}

/* ******************************************************************************* */

void MonBook::btnCopyClick(wxCommandEvent& event){
    MaListe* l=cb->getMListeV2();
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxDirDialog folder(this,_("Please choose a directory"));
            if(folder.ShowModal()==wxID_OK){
                //Get the folder where user want to organize his/her music
                wxString dossier=folder.GetPath();
                wxString annee,album,artiste,genre;

                progBar=new wxProgressDialog(_("Please wait"),_("Files are beeing copied..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(l,this,dossier);
                thread->Create();
                thread->Run();
            }
        }
    }
}

/* ******************************************************************************* */

void MonBook::btnMoveClick(wxCommandEvent& event){
    MaListe* l=cb->getMListeV2();
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxDirDialog folder(this,_("Please choose a directory"));
            if(folder.ShowModal()==wxID_OK){
                //Get the folder where user want to organize his/her music
                wxString dossier=folder.GetPath();
                OptionsHandler::setOption(_T("/notebook/tab_2/quickmove"),dossier);
                quickDir->SetLabel(_("Current quick directory : ") + dossier);
                wxString annee,album,artiste,genre;

                progBar=new wxProgressDialog(_("Please wait"),_("Files are beeing moved..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(l,this,dossier,true);
                thread->Create();
                thread->Run();

            }
        }
    }
}

/* ******************************************************************************* */

void MonBook::btnQuickMoveClick(wxCommandEvent& event){
    MaListe* l=cb->getMListeV2();
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxString quickFolder = OptionsHandler::getOption(_T("/notebook/tab_2/quickmove"),wxString(_T("")));
            if(quickFolder == wxEmptyString || wxDir::Exists(quickFolder) == false){//Quick move not usable
                wxMessageDialog msg(NULL,_("No such directory. Please use 'Move to...' button."), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
                msg.ShowModal();
            }else{
                wxString dossier=quickFolder;
                wxString annee,album,artiste,genre;

                progBar=new wxProgressDialog(_("Please wait"),_("Files are beeing moved..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(l,this,dossier,true);
                thread->Create();
                thread->Run();

            }
        }
    }
}

/* ******************************************************************************* */

wxString MonBook::ucwords(const wxString& s, int action){
    wxString res(s);
    if (action == MAKE_UPPER) res.MakeUpper();
    else if (action == MAKE_LOWER) res.MakeLower();
    else if (action == MAKE_FWL_UPPER){
        res = wxEmptyString;
        wxStringTokenizer tkz(s,wxT("\t\r\n ") + OptionsHandler::getOption(_T("/notebook/capitalize"),wxString(wxT("0123456789{}()[].~`!@#$%^&*-_+=|\\:;\"<>,?/"))),wxTOKEN_RET_DELIMS);//split string on '/'
        while(tkz.HasMoreTokens() ){
            wxString token = tkz.GetNextToken();
            res+=token.Mid(0,1).MakeUpper()+token.Mid(1).MakeLower();
        }
    }
    return res;

}

/* ******************************************************************************* */

void MonBook::btnApercuRename(wxCommandEvent& event){
    //create overview frame before processing renaming
    MaListe* l=cb->getCurrentList();
    if( comboNomFic->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
                wxString annee,album,artiste,genre;
                //Operation on typping :
                // - Remplace the "%1", "%2", "%3", et "%4" by what is associated with 
                int h=0;
                listeNoms.Clear();
                listeNoms2.Clear();
                wxArrayString listeAnciensNoms;
                wxArrayString listeNouveauxNoms;
                long AncienneSel = l->getSelection(-2);
                for (h=0 ; h<l->GetSelectedItemCount() ; h++){//for each selected files
                    //get tags
                    wxString artiste = l->getSelRowText(MaListe::ARTIST_COL,AncienneSel);
                    wxString titre = l->getSelRowText(MaListe::TITLE_COL,AncienneSel);
                    wxString album = l->getSelRowText(MaListe::ALBUM_COL,AncienneSel);
                    wxString annee = l->getSelRowText(MaListe::YEAR_COL,AncienneSel);
                    wxString genre = l->getSelRowText(MaListe::GENRE_COL,AncienneSel);
                    wxString piste = l->getSelRowText(MaListe::TRACK_COL,AncienneSel);

                    wxString SaisieStr,dir,currentName,currentDir;
                    SaisieStr = comboNomFic->GetValue();
                    //remplace the %?
                    SaisieStr.Replace(_T("%1"), titre.Trim());
                    SaisieStr.Replace(_T("%2"), artiste.Trim());
                    SaisieStr.Replace(_T("%3"), album.Trim());
                    SaisieStr.Replace(_T("%4"), annee.Trim());

                    //format track padding
                    long numPiste;
                    piste.ToLong(&numPiste);
                    wxString format = _T("%02d");
                    if(comboFormatPiste->GetValue() == _T("0")){
                          format = _T("%01d");
                    }else if(comboFormatPiste->GetValue() == _T("000")){
                          format = _T("%03d");
                    }
                    SaisieStr.Replace(_T("%5"), wxString::Format(format,numPiste));
                    SaisieStr.Replace(_T("%6"), genre.Trim());

                    //get replace char(s)
                    wxString rchar=OptionsHandler::getOption(_T("/notebook/replace_char"),wxString(_T("_")));
                    if(rchar==_T(""))
                        rchar=_T("_");
                    SaisieStr.Replace(_T("\""),rchar);
                    SaisieStr.Replace(_T("/"),rchar);
	                cleanStr(SaisieStr,rchar);
                    currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
                    currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
                    dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
                    //Get and append the extension
                    wxFileName fn(currentName);
                    wxString ext = fn.GetExt();
                    wxString newName = SaisieStr;
                    newName = wxString::Format(newName + _T("%c") + ext,_T('.'));

                    listeAnciensNoms.Add(currentName);
                    listeNouveauxNoms.Add(newName);
                    newName.Printf(l->getSelRowText(MaListe::DIR_COL,AncienneSel)+_T("%c")+newName,wxFileName::GetPathSeparator());
                    listeNoms.Add(dir);
                    listeNoms2.Add(newName);

                    AncienneSel = l->getSelection(AncienneSel);
                }
                //make the frame
                containList = new wxModalFrame(this, wxID_ANY, _("Rename"), wxPoint(200,200), wxSize(800,600),wxDEFAULT_FRAME_STYLE|wxFRAME_FLOAT_ON_PARENT);
                containList->SetBackgroundColour(wxColour(230,230,230));

                LstBox = new wxCheckListCtrl(containList);
                LstBox->InsertColumn(0, _("Old name"));
                LstBox->InsertColumn(1, _("New name"));
                LstBox->InsertColumn(2, _("State"));
                LstBox->SetColumnWidth(0, 360);
                LstBox->SetColumnWidth(1, 360);
                LstBox->SetColumnWidth(2, 70);
                //Make buttons "OK" et "Cancel"
                wxBoxSizer* sizer3=new wxBoxSizer(wxHORIZONTAL);
                wxBoxSizer* sizer4=new wxBoxSizer(wxVERTICAL);
                btnAnnuler = new wxButton(containList,MusicOrganizer::ID_ANNULER,_("Cancel"));
                btnValider = new wxButton(containList,MusicOrganizer::ID_VALIDER,_("OK"));
                sizer4->Add(LstBox,1, wxALL|wxEXPAND);
                sizer3->Add(btnValider,0);
                sizer3->Add(8,0,0);
                sizer3->Add(btnAnnuler,0,wxALL|wxEXPAND);
                sizer3->Add(8,0,0);
                sizer4->Add(0,8,0);
                sizer4->Add(sizer3,0,wxALIGN_RIGHT|wxALIGN_BOTTOM);
                sizer4->Add(0,8,0);
                containList->SetSizer(sizer4);
                containList->Centre();
                containList->Show();
                containList->Maximize();
                //Insert in list all needed
                long int k = 0;
                AncienneSel = l->getSelection(-2);
                for (k=0 ;(unsigned int)k<listeAnciensNoms.GetCount();k++){
                    LstBox->InsertItem(k,listeAnciensNoms.Item(k));
                    LstBox->SetItem(k,1,listeNouveauxNoms.Item(k));
                    LstBox->SetIcon(k,0);//check item
                    wxString cur = comboNomFic->GetValue();
                    if (cur.Find(_T("%1")) != wxNOT_FOUND){
                        if (l->getSelRowText(1,AncienneSel) == _T("")){
                            //Uncheck item if it's not ok
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%2")) != wxNOT_FOUND){
                        if (l->getSelRowText(2,AncienneSel) == _T("")){
                            //Uncheck item if it's not ok
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%3")) != wxNOT_FOUND){
                        if (l->getSelRowText(3,AncienneSel) == _T("")){
                            //Uncheck item if it's not ok
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%4")) != wxNOT_FOUND){
                        if (l->getSelRowText(4,AncienneSel) == _T("")){
                            //Uncheck item if it's not ok
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%5")) != wxNOT_FOUND){
                        if (l->getSelRowText(6,AncienneSel) == _T("")){
                            //Uncheck item if it's not ok
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%6")) != wxNOT_FOUND){
                        if (l->getSelRowText(5,AncienneSel) == _T("")){
                            //Uncheck item if it's not ok
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }

                }


            }
        }

}

/* ******************************************************************************* */

void MonBook::updateDescrSaisie(){
    wxString s = comboOrg->GetValue();
    if (s == _T(""))
        DescrSaisie->SetLabel(_T(""));
    wxRegEx invalid(wxT("[\\:*?\"<>|]"));
    if (invalid.Matches(s)){
        comboOrg->SetValue(text1);
        comboOrg->SetInsertionPointEnd();
        s = text1;
    }else{
        text1 = s;
    }
    s.Replace(_T("%1"), _("<Artist>"));
    s.Replace(_T("%2"), _("<Album>"));
    s.Replace(_T("%3"), _("<Year>"));
    s.Replace(_T("%4"), _("<Genre>"));
    DescrSaisie->SetValue(s);
}

/* ******************************************************************************* */

void MonBook::updateDescrSaisie2(){
    wxString s = comboNomFic->GetValue();
    if (s == _T(""))
        DescrSaisie->SetLabel(_T(""));
    wxRegEx invalid(wxT("[\\:*?\"<>|/]"));
    if (invalid.Matches(s)){
        comboNomFic->SetValue(text2);
        comboNomFic->SetInsertionPointEnd();
        s = text2;
    }else{
        text2 = s;
    }
    s.Replace(_T("%1"), _("<Title>"));
    s.Replace(_T("%2"), _("<Artist>"));
    s.Replace(_T("%3"), _("<Album>"));
    s.Replace(_T("%4"), _("<Year>"));
    s.Replace(_T("%5"), _("<Track>"));
    s.Replace(_T("%6"), _("<Genre>"));
    DescrSaisie2->SetValue(s);
}

/* ******************************************************************************* */

void MonBook::textWriting(wxCommandEvent& event){
     updateDescrSaisie();
}

/* ******************************************************************************* */

void MonBook::textWriting2(wxCommandEvent& event){
     updateDescrSaisie2();
}

/* ******************************************************************************* */

void MonBook::textWritingNumbers2(wxCommandEvent& event){
    //remove not number chars typpen
    wxString s = comboPiste->GetValue();
    long offset=0; //the event isn't launched at the same time under windows and under *nix
#ifdef __WXMSW__ 
    offset=1;
#else
    if(s.Length()==0)
        offset=1;
#endif
    if (not s.IsNumber())
        comboPiste->Remove(comboPiste->GetLastPosition() - offset,comboPiste->GetLastPosition()-offset+1);
    else{
        long len;
        s.ToLong(&len);
        if (len > 9999)
            comboPiste->Remove(comboPiste->GetLastPosition() -offset,comboPiste->GetLastPosition()-offset+1);
    }

}

/* ******************************************************************************* */

void MonBook::textWritingNumbers(wxCommandEvent& event){
    wxString s = comboAnne->GetValue();
    long offset=0;
#ifdef __WXMSW__
    offset=1;
#else
    if(s.Length()==0)
        offset=1;
#endif
    if (not s.IsNumber())
        comboAnne->Remove(comboAnne->GetLastPosition()- offset,comboAnne->GetLastPosition()-offset+1);
    else{
        long len;
        s.ToLong(&len);
        if (len > 9999)
            comboAnne->Remove(comboAnne->GetLastPosition() -offset,comboAnne->GetLastPosition()-offset+1);
    }

}

/* ******************************************************************************* */

void MonBook::btnAnnulerClick(wxCommandEvent& event){
    containList->Close();
}

/* ******************************************************************************* */

void MonBook::btnValiderClick(wxCommandEvent& event){
    //process renaming
    int h=0;
    MaListe *l=cb->getCurrentList();
    MaListe *l2=cb->getOtherList();
    long AncienneSel = l->getSelection(-2);
    wxString n;
    wxListItem i;
    i.SetMask(wxLIST_MASK_TEXT);
    i.SetColumn(1);
    for (h=0 ; h<LstBox->GetItemCount();h++){//for each item
        if (LstBox->IsChecked((long)h)){//if the user realy want to rename it
            AncienneSel = l->getSelection(AncienneSel);
            try{ //wxRename may fails
                wxRenameFile(listeNoms[h],listeNoms2[h]);
                LstBox->SetItem(h,2,_("<OK>"));
                i.SetId(h);
                LstBox->GetItem(i);
                n=i.GetText();
                l->SetItem(AncienneSel,0,n);
                l2->SetItem(AncienneSel,0,n);
            }catch(...){
                LstBox->SetItem(h,2,_("<ERROR>"));
            }
        }
    }
    //Change the OK button
    btnAnnuler->SetLabel(_("Close"));
    btnValider->Destroy();
}

/* ******************************************************************************* */

void MonBook::btnValiderGenClick(wxCommandEvent& event){
    //write generated tags
    int h=0;
    bool ID3V1and2 = chkGenAll->IsChecked();
    bool dontCopyEmptySource = chkNoEmptyGen->IsChecked();
    int copyOnlyEmptyTarget = radioGen->GetSelection();
    bool isID3V2 = cb->isID3V2();

    MaListe *l=cb->getCurrentList();
    MaListe* otherLst = cb->getOtherList();
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    wxString titreStr,artistStr,albumStr,yearStr,genreStr,trackStr;
    wxListItem titre,artist,album,year,genre,track;
    titre.SetMask(wxLIST_MASK_TEXT);
    artist.SetMask(wxLIST_MASK_TEXT);
    album.SetMask(wxLIST_MASK_TEXT);
    year.SetMask(wxLIST_MASK_TEXT);
    genre.SetMask(wxLIST_MASK_TEXT);
    track.SetMask(wxLIST_MASK_TEXT);
    titre.SetColumn(1);
    artist.SetColumn(2);
    album.SetColumn(3);
    year.SetColumn(4);
    genre.SetColumn(5);
    track.SetColumn(6);
    for (h=0 ; h < LstBox->GetItemCount();h++){//for each item of the generating overview
        currentSel = l->getSelection(AncienneSel);
        wxString currentDir = l->getSelRowText(MaListe::DIR_COL,AncienneSel);
        wxString currentName = l->getSelRowText(MaListe::NAME_COL,AncienneSel);
        wxString dir;
        dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
        TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
        ff->setDefaultTextEncoding(TagLib::String::UTF8);
        TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
        fic.setID3v2FrameFactory(ff);
        if (LstBox->IsChecked((long)h)){//if the user realy wanted to edit the tags
            titre.SetId(h);
            artist.SetId(h);
            album.SetId(h);
            year.SetId(h);
            genre.SetId(h);
            track.SetId(h);
            LstBox->GetItem(titre);
            LstBox->GetItem(artist);
            LstBox->GetItem(album);
            LstBox->GetItem(year);
            LstBox->GetItem(genre);
            LstBox->GetItem(track);
            titreStr = titre.GetText();
            artistStr = artist.GetText();
            albumStr = album.GetText();
            yearStr = year.GetText();
            genreStr = genre.GetText();
            trackStr = track.GetText();
            try{
                //tags writting
                if (ID3V1and2 || isID3V2){
                    if (!(trackStr == _T("") && dontCopyEmptySource)){
                        long t;
                        trackStr.ToLong(&t);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TRACK_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            fic.ID3v2Tag(true)->setTrack((int)t);
                        }
                    }
                    if (!(genreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)genreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::GENRE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            fic.ID3v2Tag(true)->setGenre(s);
                        }
                    }
                    if (!(yearStr == _T("") && dontCopyEmptySource)){
                        long y;
                        yearStr.ToLong(&y);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::YEAR_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            fic.ID3v2Tag(true)->setYear((int)y);
                        }
                    }
                    if (!(artistStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)artistStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ARTIST_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            fic.ID3v2Tag(true)->setArtist(s);
                        }
                    }
                    if (!(albumStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)albumStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ALBUM_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            fic.ID3v2Tag(true)->setAlbum(s);
                        }
                    }
                    if (!(titreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)titreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TITLE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            fic.ID3v2Tag(true)->setTitle(s);
                        }
                    }
                }
                if(ID3V1and2 || !(isID3V2)){
                    if (!(trackStr == _T("") && dontCopyEmptySource)){
                        long t;
                        trackStr.ToLong(&t);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TRACK_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TRACK_COL,trackStr);
                            fic.ID3v1Tag(true)->setTrack((int)t);
                        }
                    }
                    if (!(genreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)genreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::GENRE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::GENRE_COL,genreStr);
                            fic.ID3v1Tag(true)->setGenre(s);
                        }
                    }
                    if (!(yearStr == _T("") && dontCopyEmptySource)){
                        long y;
                        yearStr.ToLong(&y);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::YEAR_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::YEAR_COL,yearStr);
                            fic.ID3v1Tag(true)->setYear((int)y);
                        }
                    }
                    if (!(artistStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)artistStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ARTIST_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ARTIST_COL,artistStr);
                            fic.ID3v1Tag(true)->setArtist(s);
                        }
                    }
                    if (!(albumStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)albumStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::ALBUM_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::ALBUM_COL,albumStr);
                            fic.ID3v1Tag(true)->setAlbum(s);
                        }
                    }
                    if (!(titreStr == _T("") && dontCopyEmptySource)){
                        TagLib::String s((char const*)titreStr.mb_str(wxConvUTF8),TagLib::String::UTF8);
                        if (!(copyOnlyEmptyTarget == 1 && l->getSelRowText(MaListe::TITLE_COL,AncienneSel) != _T(""))){
                            l->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            if (ID3V1and2)
                                otherLst->SetItem(currentSel,MaListe::TITLE_COL,titreStr);
                            fic.ID3v1Tag(true)->setTitle(s);
                        }
                    }
                }
                LstBox->SetItem(h,7,_("<OK>"));
            }catch(...){
                LstBox->SetItem(h,7,_("<ERROR>"));
            }
        }
        if (ID3V1and2 || isID3V2)
            fic.save(TagLib::MPEG::File::ID3v2,false);
        if(ID3V1and2 || !(isID3V2))
            fic.save(TagLib::MPEG::File::ID3v1,false);
        AncienneSel = l->getSelection(AncienneSel);
    }
    btnAnnuler->SetLabel(_("Close"));
    btnValider->Destroy();
}

/* ******************************************************************************* */

void MonBook::cpyMoveThreadMsg(wxCommandEvent& event){
    int type=event.GetInt();
    if(type==-1){//update progBar
        if(!progBar->Update(thread->getProg()))
            thread->end();
    }else{//Copying or Moving finished
        progBar->Destroy();
        if (type != 0){//some errors has occured during operation
            if (type == 1){
                wxMessageDialog msg(NULL,_("1 error while performing task"), _("Error"),wxICON_HAND|wxOK);
                msg.ShowModal();
            }else{
                wxString err=wxString::Format(_T("%d"),type);
                wxMessageDialog msg(NULL,err + _(" errors while performing task"), _("Error"),wxICON_HAND|wxOK);
                msg.ShowModal();
            }
        }

        arbo->refresh();
    }
}

/* ******************************************************************************* */

void MonBook::saveTabs(){
    if(OptionsHandler::getOption(_T("/notebook/save_content"),true)==false)
        return;
    OptionsHandler::setOption(_T("/notebook/comboCopyMove_val"),comboOrg->GetValue());
    OptionsHandler::setOption(_T("/notebook/comboRename_val"),comboNomFic->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_4/replace"),radio->GetSelection());
    OptionsHandler::setOption(_T("/notebook/tab_4/copie"),chkNoEmpty->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/title"),chkTitre->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/artist"),chkArtiste->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/album"),chkAlbum->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/genre"),chkGenre->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/track"),chkPiste->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/year"),chkAnne->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_4/capitalize"),chooseCase->GetSelection());
    //Tab 5
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_ID3V1and2"),chkGenAll->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_no_empty"),chkNoEmptyGen->IsChecked());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_replace"),radioGen->GetSelection());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_separators"),txtSeparator->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_title"),txtTitreGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_artist"),txtInterpreteGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_album"),txtAlbumGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_year"),comboAnneGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_track"),txtPisteGen->GetValue());
    OptionsHandler::setOption(_T("/notebook/tab_5/gen_genre"),comboGenreGen->GetValue());
}

/* ******************************************************************************* */

void MonBook::restoreTabs(){
    if(OptionsHandler::getOption(_T("/notebook/save_content"),true)==false)
        return;
    comboOrg->SetValue(OptionsHandler::getOption(_T("/notebook/comboCopyMove_val")));
    comboNomFic->SetValue(OptionsHandler::getOption(_T("/notebook/comboRename_val")));
    wxString str;
    radio->SetSelection(OptionsHandler::getOption(_T("/notebook/tab_4/replace"),false));
    chkNoEmpty->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/copie"),true));
    chkTitre->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/title"),false));
    chkArtiste->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/artist"),false));
    chkAlbum->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/album"),false));
    chkGenre->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/genre"),false));
    chkPiste->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/track"),false));
    chkAnne->SetValue(OptionsHandler::getOption(_T("/notebook/tab_4/year"),false));
    chooseCase->SetSelection(OptionsHandler::getOption(_T("/notebook/tab_4/capitalize"),0));
    //Tab 5
    chkGenAll->SetValue(OptionsHandler::getOption(_T("/notebook/tab_5/gen_ID3V1and2"),false));
    chkNoEmptyGen->SetValue(OptionsHandler::getOption(_T("/notebook/tab_5/gen_no_empty"),true));
    radioGen->SetSelection(OptionsHandler::getOption(_T("/notebook/tab_5/gen_replace"),1));
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_separators"),wxString(_T("_-_:")));
    if (str == _T(""))
        str = _T("_-_:");
    txtSeparator->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_title"));
    txtTitreGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_artist"));
    txtInterpreteGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_album"));
    txtAlbumGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_year"));
    comboAnneGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_track"));
    txtPisteGen->SetValue(str);
    str = OptionsHandler::getOption(_T("/notebook/tab_5/gen_genre"));
    comboGenreGen->SetValue(str);

    updateDescrSaisie2();
    updateDescrSaisie();
}

/* ******************************************************************************* */

void MonBook::gen(wxString& ret, wxString str, wxString regex){
    //generate regex from options choosen in the generate tab
    wxRegEx exp(regex);
    exp.Replace(&str,wxString(_T("|")));
    //File name exploding in Array
    wxArrayString liste; // list assiociated with %1 - %99
    while (str.Find(_T('|')) != wxNOT_FOUND){
        int j = str.Find(_T('|'));
        wxString tmpSep;
        if (j != 0)
            liste.Add(str.SubString(0,j - 1));
        if ((unsigned int)(j+1) >= str.Len())
            str = _T("");
        else
            str = str.SubString(j+1,str.Len()-1);
    }
    liste.Add(str.SubString(0,str.Len()-1));
    //Replacing
    char chiffre[2];
    for (int i=1; i<=99;i++){
        sprintf(chiffre,"%d",i);
        if ((unsigned int)i > liste.GetCount())
            ret.Replace(wxString(_T("%")) + wxString(chiffre,wxConvUTF8),_T(""));
        else
            ret.Replace(wxString(_T("%")) + wxString(chiffre,wxConvUTF8),liste[i-1]);
    }
}

/* ******************************************************************************* */

void MonBook::generateTags(wxCommandEvent& event){
    //generate tags and show overview
    MaListe* l = cb->getCurrentList();
    if( l->GetSelectedItemCount()==0){
        wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
        msg.ShowModal();
    }else{
        wxString titre,piste,annee,album,artiste,genre,nom;
        int h=0;
        listeNoms.Clear();
        listeNoms2.Clear();
        wxArrayString listeAnciensNoms;
        wxArrayString listeNouveauxNoms;

        containList = new wxModalFrame(this, wxID_ANY, _("Rename"), wxPoint(200,200), wxSize(800,600),wxDEFAULT_FRAME_STYLE|wxFRAME_FLOAT_ON_PARENT);
        containList->SetBackgroundColour(wxColour(230,230,230));
        //ListBox whith checkbox building
        LstBox = new wxCheckListCtrl(containList);
        LstBox->InsertColumn(0, _("Name"));
        LstBox->InsertColumn(1, _("Title"));
        LstBox->InsertColumn(2, _("Artist"));
        LstBox->InsertColumn(3, _("Album"));
        LstBox->InsertColumn(4, _("Year"));
        LstBox->InsertColumn(5, _("Genre"));
        LstBox->InsertColumn(6, _("Track"));
        LstBox->InsertColumn(7, _("State"));
        LstBox->SetColumnWidth(0, 360);
        LstBox->SetColumnWidth(1, 140);
        LstBox->SetColumnWidth(2, 100);
        LstBox->SetColumnWidth(3, 100);
        LstBox->SetColumnWidth(4, 80);
        LstBox->SetColumnWidth(5, 100);
        LstBox->SetColumnWidth(6, 60);
        LstBox->SetColumnWidth(7, 70);
        //Buttons "OK" and "Cancel" making
        wxBoxSizer* sizer3=new wxBoxSizer(wxHORIZONTAL);
        wxBoxSizer* sizer4=new wxBoxSizer(wxVERTICAL);
        btnAnnuler = new wxButton(containList,MusicOrganizer::ID_ANNULER,_("Cancel"));
        btnValider = new wxButton(containList,ID_VALIDER_GEN,_("OK"));
        sizer4->Add(LstBox,1, wxALL|wxEXPAND);
        sizer3->Add(btnValider,0);
        sizer3->Add(8,0,0);
        sizer3->Add(btnAnnuler,0,wxALL|wxEXPAND);
        sizer3->Add(8,0,0);
        sizer4->Add(0,8,0);
        sizer4->Add(sizer3,0,wxALIGN_RIGHT|wxALIGN_BOTTOM);
        sizer4->Add(0,8,0);
        containList->SetSizer(sizer4);

        long AncienneSel = l->getSelection(-2);
        for (h=0 ; h<l->GetSelectedItemCount() ; h++){//for each selected files
            nom = l->getSelRowText(MaListe::NAME_COL,AncienneSel);  //abcd.mp3
            nom = nom.Remove(nom.Find(_T('.'),true));               //abcd
            wxString dir,currentName,currentDir;
            titre = txtTitreGen->GetValue();
            artiste = txtInterpreteGen->GetValue();
            album = txtAlbumGen->GetValue();
            annee = comboAnneGen->GetValue();
            piste = txtPisteGen->GetValue();
            genre = comboGenreGen->GetValue();
            wxString reg;
            wxString sep = txtSeparator->GetValue();
            //RegExp from separators
            while (sep.Find(_T(':')) != wxNOT_FOUND){
                int j = sep.Find(_T(':'));
                if (sep.Len() == 1){
                    sep = _T("");
                }else{
                    if (j == 0){
                        sep = sep.SubString(1,sep.Len()-1);
                    }else if((unsigned int)(j+1) >= sep.Len()){
                        sep = sep.SubString(0,sep.Len()-2);
                        reg += _T("(") + sep + _T(")|");
                    }else{
                        reg += _T("(") + sep.SubString(0,j - 1) + _T(")|");
                        sep = sep.SubString(j+1,sep.Len()-1);
                    }
                }
            }
            if (sep != _T(""))
                reg += _T("(") + sep + _T(")");
            if (reg.SubString(reg.Len()-1,reg.Len()-1) == wxString(_T("|")))
                reg = reg.SubString(0,reg.Len()-2);
            //Replacing
            gen(titre,nom,reg);
            gen(artiste,nom,reg);
            gen(album,nom,reg);
            gen(annee,nom,reg);
            gen(piste,nom,reg);
            gen(genre,nom,reg);
            long numPiste,hl=(long int)h;
            piste.ToLong(&numPiste);
            LstBox->InsertItem(h,nom);
            LstBox->SetItem(h,1,titre);
            LstBox->SetItem(h,2,artiste);
            LstBox->SetItem(h,3,album);
            LstBox->SetItem(h,4,annee);
            LstBox->SetItem(h,5,genre);
            LstBox->SetItem(h,6,piste);
            LstBox->SetIcon(hl,0);
            AncienneSel = l->getSelection(AncienneSel);
        }
        containList->Center();
        containList->Show();
        containList->Maximize();
    }
}

/* ******************************************************************************* */

void MonBook::generateTracks(wxCommandEvent& event){
    TrackFrame* fenetre = new TrackFrame(this,cb);
    fenetre->Show();
}

/* ******************************************************************************* */

void MonBook::btnCopyTag(wxCommandEvent& event){
    //Copy tag from a the current selected list to the other
    bool isTitre = chkTitre->IsChecked();
    bool isArtiste = chkArtiste->IsChecked();
    bool isGenre = chkGenre->IsChecked();
    bool isAlbum = chkAlbum->IsChecked();
    bool isAnne = chkAnne->IsChecked();
    bool isPiste = chkPiste->IsChecked();
    bool dontCopyEmptySource = chkNoEmpty->IsChecked();
    bool isID3V2 = cb->isID3V2();
    int intCase = chooseCase->GetSelection();
    int copyOnlyEmptyTarget = radio->GetSelection();
    MaListe* curLst = cb->getCurrentList();
    MaListe* otherLst = cb->getOtherList();

    long AncienneSel = curLst->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)curLst->GetSelectedItemCount() ; i++){//for each selected items
       currentSel = curLst->getSelection(AncienneSel);
       wxString currentDir = curLst->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName = curLst->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
       TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
       ff->setDefaultTextEncoding(TagLib::String::UTF8);
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
       fic.setID3v2FrameFactory(ff);

       //TITLE
       if (isTitre){
           wxString titre = curLst->getSelRowText(MaListe::TITLE_COL,AncienneSel);
           if (intCase != 0) titre = ucwords(titre,intCase);
           if (!(titre == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)titre.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::TITLE_COL,titre);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::TITLE_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setTitle(s);
                   else fic.ID3v2Tag(true)->setTitle(s);
               }
           }
       }

       //ARTIST
       if (isArtiste){
           wxString artiste = curLst->getSelRowText(MaListe::ARTIST_COL,AncienneSel);
           if (intCase != 0) artiste = ucwords(artiste,intCase);
           if (!(artiste == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)artiste.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::ARTIST_COL,artiste);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::ARTIST_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setArtist(s);
                   else fic.ID3v2Tag(true)->setArtist(s);
               }
           }
       }

       //ALBUM
       if (isAlbum){
           wxString album = curLst->getSelRowText(MaListe::ALBUM_COL,AncienneSel);
           if (intCase != 0) album = ucwords(album,intCase);
           if (!(album == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)album.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::ALBUM_COL,album);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::ALBUM_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setAlbum(s);
                   else fic.ID3v2Tag(true)->setAlbum(s);
               }
           }
       }

       //GENRE
       if (isGenre){
           wxString genre = curLst->getSelRowText(MaListe::GENRE_COL,AncienneSel);
           if (intCase != 0) genre = ucwords(genre,intCase);
           if (!(genre == _T("") && dontCopyEmptySource)){
               TagLib::String s((char const*)genre.mb_str(wxConvUTF8),TagLib::String::UTF8);
               otherLst->SetItem(currentSel,MaListe::GENRE_COL,genre);
               if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::GENRE_COL,AncienneSel) != _T(""))){
                   if (isID3V2) fic.ID3v1Tag(true)->setGenre(s);
                   else fic.ID3v2Tag(true)->setGenre(s);
               }
           }
       }

       //YEAR
       if (isAnne){
           try{
               long y;
               curLst->getSelRowText(MaListe::YEAR_COL,AncienneSel).ToLong(&y);
               if (!(curLst->getSelRowText(MaListe::YEAR_COL,AncienneSel) == _T("") && dontCopyEmptySource)){
                   if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::YEAR_COL,AncienneSel) != _T(""))){
                       if (isID3V2) fic.ID3v1Tag(true)->setYear((int)y);
                       else fic.ID3v2Tag(true)->setYear((int)y);
                   }
               }
           }catch(...){}
           otherLst->SetItem(currentSel,MaListe::YEAR_COL,curLst->getSelRowText(MaListe::YEAR_COL,AncienneSel));
       }

       //TRACK
       if (isPiste){
           try{
               long t;
               curLst->getSelRowText(MaListe::TRACK_COL,AncienneSel).ToLong(&t);
               if (!(curLst->getSelRowText(MaListe::TRACK_COL,AncienneSel) == _T("") && dontCopyEmptySource)){
                   if (!(copyOnlyEmptyTarget == 1 && otherLst->getSelRowText(MaListe::TRACK_COL,AncienneSel) != _T(""))){
                       if (isID3V2) fic.ID3v1Tag(true)->setTrack((int)t);
                       else fic.ID3v2Tag(true)->setTrack((int)t);
                   }
               }
           }catch(...){}
           otherLst->SetItem(currentSel,MaListe::TRACK_COL,curLst->getSelRowText(MaListe::TRACK_COL,AncienneSel));
       }

       //SAVE
       if (isID3V2)
           fic.save(TagLib::MPEG::File::ID3v1,false);
       else
           fic.save(TagLib::MPEG::File::ID3v2,false);

       AncienneSel = currentSel;
    }
}

/* ******************************************************************************* 
   ******************************************************************************* */

TrackFrame::TrackFrame( wxWindow* parent,MonChoicebook *c, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style ) : wxFrame( parent, id, title, pos, size, style ){
	choiceBook = c;
	this->SetSizeHints( wxDefaultSize, wxDefaultSize );

	wxBoxSizer* bSizer45;
	bSizer45 = new wxBoxSizer( wxVERTICAL );

	m_panel6 = new wxPanel( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
	wxBoxSizer* bSizer46;
	bSizer46 = new wxBoxSizer( wxVERTICAL );

	lblDescription = new wxStaticText( m_panel6, wxID_ANY, _("You can automatically fill in track numbers.\nAttention :\nMake sure that the list is sorted by folders !"), wxDefaultPosition, wxDefaultSize, 0 );
	lblDescription->Wrap( -1 );
	bSizer46->Add( lblDescription, 0, wxALL, 5 );


	bSizer46->Add( 0, 0, 1, wxEXPAND, 5 );

	wxBoxSizer* bSizer47;
	bSizer47 = new wxBoxSizer( wxHORIZONTAL );

	m_staticText29 = new wxStaticText( m_panel6, wxID_ANY, _("Start with :"), wxDefaultPosition, wxDefaultSize, 0 );
	m_staticText29->Wrap( -1 );
	bSizer47->Add( m_staticText29, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	wxArrayString m_choice2Choices;
	m_choice2 = new wxChoice( m_panel6, wxID_ANY, wxDefaultPosition, wxSize( 50,-1 ), m_choice2Choices, 0 );
	for (int i=1 ; i<=99 ; i++){
		m_choice2->Append(wxString::Format(wxT("%d"),i));
	}
	m_choice2->SetSelection( 0 );
	bSizer47->Add( m_choice2, 0, wxALL, 5 );

	bSizer46->Add( bSizer47, 0, wxEXPAND, 5 );


	bSizer46->Add( 0, 0, 1, wxEXPAND, 5 );

	chkID3V1and2 = new wxCheckBox( m_panel6, wxID_ANY, _("Generate ID3V1 and ID3V2"), wxDefaultPosition, wxDefaultSize, 0 );
	chkID3V1and2->SetValue(OptionsHandler::getOption(_T("/trackframe/id3v1and2"),false));

	bSizer46->Add( chkID3V1and2, 0, wxALL, 5 );

	chkCounter = new wxCheckBox( m_panel6, wxID_ANY, _("Reset counter on new folder"), wxDefaultPosition, wxDefaultSize, 0 );
	chkCounter->SetValue(OptionsHandler::getOption(_T("/trackframe/restartOnFolder"),true));

	bSizer46->Add( chkCounter, 0, wxALL, 5 );

	wxBoxSizer* bSizer48;
	bSizer48 = new wxBoxSizer( wxHORIZONTAL );


	bSizer48->Add( 0, 0, 1, wxEXPAND, 5 );

	btnGenTrack = new wxButton( m_panel6, ID_PISTE_GEN, _("Generate"), wxDefaultPosition, wxDefaultSize, 0 );
	bSizer48->Add( btnGenTrack, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	btnCancelTrack = new wxButton( m_panel6, ID_CLOSE, _("Close"), wxDefaultPosition, wxDefaultSize, 0 );
	bSizer48->Add( btnCancelTrack, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5 );

	bSizer46->Add( bSizer48, 1, wxEXPAND, 5 );

	m_panel6->SetSizer( bSizer46 );
	m_panel6->Layout();
	bSizer46->Fit( m_panel6 );
	bSizer45->Add( m_panel6, 1, wxEXPAND | wxALL, 0 );

	this->SetSizer( bSizer45 );
	this->Layout();
}

/* ******************************************************************************* */

void TrackFrame::genTracks(wxCommandEvent& event){
    bool isID3V2 = choiceBook->isID3V2();
    bool ID3v1Andv2 = chkID3V1and2->IsChecked();
    bool restartOnFolder = chkCounter->IsChecked();
    long deb;
    m_choice2->GetStringSelection().ToLong(&deb);//the number to begin
    int cpt = (int)deb - 1;
    MaListe* curLst = choiceBook->getCurrentList();
    MaListe* otherLst = choiceBook->getOtherList();
    wxString oldDir;

    long ancienneSel = curLst->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<(unsigned int)curLst->GetSelectedItemCount() ; i++){//for each selected item
        currentSel = curLst->getSelection(ancienneSel);

        wxString currentDir = curLst->getSelRowText(MaListe::DIR_COL,ancienneSel);
        wxString currentName = curLst->getSelRowText(MaListe::NAME_COL,ancienneSel);
        wxString dir;//the full path of the item file 
        dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
        TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
        ff->setDefaultTextEncoding(TagLib::String::UTF8);
        TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
        fic.setID3v2FrameFactory(ff);

        if (i != 0 && restartOnFolder && oldDir != currentDir)
            cpt = (int)deb;//(re)initialize the counter
        else
            cpt++;

        //write track tag in the file
        try{
            if(ID3v1Andv2){
                fic.ID3v1Tag(true)->setTrack(cpt);
                fic.ID3v2Tag(true)->setTrack(cpt);
                otherLst->SetItem(currentSel,MaListe::TRACK_COL,wxString::Format(wxT("%d"),cpt));
            }
            else if (isID3V2)
                fic.ID3v2Tag(true)->setTrack(cpt);
            else
                fic.ID3v1Tag(true)->setTrack(cpt);
        }catch(...){}
        curLst->SetItem(currentSel,MaListe::TRACK_COL,wxString::Format(wxT("%d"),cpt));

        //SAVE
        if(ID3v1Andv2){
            fic.save(TagLib::MPEG::File::ID3v1,false);
            fic.save(TagLib::MPEG::File::ID3v2,false);
        }
        else if (isID3V2)
            fic.save(TagLib::MPEG::File::ID3v2,false);
        else
            fic.save(TagLib::MPEG::File::ID3v1,false);

        ancienneSel = currentSel;
        oldDir = currentDir;
    }
    OptionsHandler::setOption(_T("/trackframe/id3v1and2"),chkID3V1and2->IsChecked());
    OptionsHandler::setOption(_T("/trackframe/restartOnFolder"),chkCounter->IsChecked());
    this->Destroy();
}

/* ******************************************************************************* */

void TrackFrame::Close(wxCommandEvent& event){
    OptionsHandler::setOption(_T("/trackframe/id3v1and2"),chkID3V1and2->IsChecked());
    OptionsHandler::setOption(_T("/trackframe/restartOnFolder"),chkCounter->IsChecked());
    this->Destroy();
}

/*void MonBook::btnCleanID3v2Click(wxCommandEvent& event){
    if(liste->GetSelectedItemCount()==0)
        return;
    MaListe* l=(MaListe*)liste;
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<liste->GetSelectedItemCount() ; i++){
        currentSel = l->getSelection(AncienneSel);
        wxString currentDir=l->getSelRowText(8,AncienneSel);
        wxString currentName=l->getSelRowText(0,AncienneSel);
        wxString dir;
        dir.Printf(currentDir+wxT("%c")+currentName,wxFileName::GetPathSeparator());
        TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);

        TagLib::String artist = fic.tag()->artist();
        TagLib::String titre = fic.tag()->title();
        TagLib::String album = fic.tag()->album();
        TagLib::String genre = fic.tag()->genre();

        wxString ar(artist.toCString(false),wxConvISO8859_1);
        wxString t(titre.toCString(false),wxConvISO8859_1);
        wxString al(album.toCString(false),wxConvISO8859_1);
        wxString g(genre.toCString(false),wxConvISO8859_1);

        ar.Replace(_T("\xFF"),_T(""));
        al.Replace(_T("\xFF"),_T(""));
        g.Replace(_T("\xFF"),_T(""));
        t.Replace(_T("\xFF"),_T(""));
        ar.Trim();
        al.Trim();
        g.Trim();
        t.Trim();

        artist = (char const*)ar.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setArtist(artist);

        titre = (char const*)t.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setTitle(titre);

        album = (char const*)al.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setAlbum(album);

        genre = (char const*)g.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setGenre(genre);

        fic.save(TagLib::MPEG::File::ID3v2,false);//On ne sauvegarde que les ID3v2
        AncienneSel = currentSel;
    }
    wxMessageDialog dlg_fin(NULL,_T("Nettoyage reussi"),_T("Traitement accompli"), wxICON_INFORMATION | wxOK);
    dlg_fin.ShowModal();
}*/


