/***************************************************************************
 * Name:      Music_Organizer__Main.cpp                                    *
 * Purpose:   Code for Application Frame                                   *
 * Author:    Jackie Team (jackie.team@gmail.com)                          *
 * Created:   2007-11-26                                                   *
 * Copyright: Jackie Team (www.musicorganizer.org)                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "Music_Organizer__Main.h"
#ifndef __WXMSW__ && __WXMAC__
#include "images/icon.xpm"
#endif


BEGIN_EVENT_TABLE ( Music_Organizer__Frame, wxFrame )
	EVT_CLOSE ( Music_Organizer__Frame::OnClose )
	EVT_KEY_UP (Music_Organizer__Frame::onKeyUp)
	EVT_MENU ( idMenuQuit, Music_Organizer__Frame::OnQuit )
	EVT_MENU ( idMenuAbout, Music_Organizer__Frame::OnAbout )
	EVT_MENU ( idMenuHelp, Music_Organizer__Frame::OnHelp )
	EVT_MENU ( idMenuRefresh, Music_Organizer__Frame::onRefresh)
	EVT_MENU ( idMenuDel, Music_Organizer__Frame::onDel)
	EVT_MENU ( idMenuSel, Music_Organizer__Frame::onSel)
	EVT_MENU ( idMenuOp, Music_Organizer__Frame::onOp)
	EVT_MENU ( MusicOrganizer::ID_MSG, Music_Organizer__Frame::changeMenu)
	EVT_MENU ( MusicOrganizer::ID_HIST, Music_Organizer__Frame::updateHist)
	//Handle all events about history current item changin
	EVT_MENU ( MusicOrganizer::ID_HIST+1, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+2, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+3, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+4, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+5, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+6, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+7, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+8, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+9, Music_Organizer__Frame::changePath)
	EVT_MENU ( MusicOrganizer::ID_HIST+10, Music_Organizer__Frame::changePath)
END_EVENT_TABLE()

//helper functions
enum wxbuildinfoformat
{
	short_f, long_f
};

#ifdef __WXMAC__
wxString MusicOrganizer::stFindResourceFile(const char * name, const char * extension)
// Find the full path of file name.extension in the resource folder of the bundle -- may be blank
{
	//GetBundleSharedSupportDir()

	CFBundleRef mainbundle = CFBundleGetMainBundle(); // Ref is NOT owned by us
	if(!mainbundle)
	{
		wxLogDebug(_T("Application is not bundled!"));
		return wxEmptyString;
	}
	//If you have only one name, myfilename.gif, you could do this...
	//CFStringRef stSpl = CFSTR("myfilename");
	//CFStringRef stBmp = CFSTR("gif");
	
	CFStringRef stSpl = CFStringCreateWithCString ( NULL, name, kCFStringEncodingASCII  );
	CFStringRef stBmp = CFStringCreateWithCString ( NULL, extension, kCFStringEncodingASCII  );
	CFURLRef CFurl = CFBundleCopyResourceURL(mainbundle,stSpl,stBmp,NULL);
	if(!CFurl)
	{
		wxLogDebug(_T("Couldn't get executable URL"));
		return wxEmptyString;
	}
	CFIndex bufLen = 1024;
	unsigned char buffer[1024];
	if(!CFURLGetFileSystemRepresentation(CFurl, TRUE, buffer, bufLen))
	{
		CFRelease(CFurl);
		wxLogDebug(_T("Failed to get FS representation"));
		return wxEmptyString;
	}
	// The docs on CFURLGetFileSystemRepresentation are unclear, be safe.
	buffer[1023] = '\0';
	CFRelease(CFurl);
	return wxString((const char*)buffer,wxConvUTF8);
}
#endif

Music_Organizer__Frame::Music_Organizer__Frame ( wxFrame *frame, const wxString& title )
		: wxFrame ( frame, -1, title )
{
	OptionsHandler::loadOptions();
	if( OptionsHandler::getOption(_T("/app/language"),wxLocale::GetSystemLanguage()) !=wxLANGUAGE_UNKNOWN){
		m_locale.Init( OptionsHandler::getOption(_T("/app/language"),wxLocale::GetSystemLanguage()), wxLOCALE_CONV_ENCODING | wxLOCALE_LOAD_DEFAULT);
		#ifdef __WXMAC__
		if(wxDirExists( _T ( "./po" ) ))
		wxLocale::AddCatalogLookupPathPrefix(wxT("./po"));
		else
		wxLocale::AddCatalogLookupPathPrefix( MusicOrganizer::stFindResourceFile ( "po","" ));
		#else
			wxLocale::AddCatalogLookupPathPrefix(wxT("./po"));
		#endif
			m_locale.AddCatalog(wxT("musicorganizer"));
	}

#if wxUSE_MENUS
	// create a menu bar
	histMenu = new wxMenu ( _T ( "" ) );
	wxMenuItem* item;
	wxString label;
	int i=1,index=OptionsHandler::getOption(_T("/tree/history/index"),0);
	label = OptionsHandler::getOption(_T("/tree/history/path1"));
	if(!OptionsHandler::getOption(_T("/tree/has_history"),true)) label==_T("");
	while(label!=_T("") && i<=10){
		item=histMenu->AppendRadioItem(MusicOrganizer::ID_HIST+i,label);
		if(i==index) item->Check();
		i++;
		label = OptionsHandler::getOption(wxString::Format(_T("/tree/history/path%d"),i));
	}

	#ifdef __WXMAC__
		//Improve Mac Menu itegration
		wxApp::s_macAboutMenuItemId = idMenuAbout;
		wxApp::s_macPreferencesMenuItemId = idMenuOp;
		wxApp::s_macHelpMenuTitleName = _("Help");
	#endif
	wxMenuBar* mbar = new wxMenuBar();

	wxMenu* fileMenu = new wxMenu ( _T ( "" ) );
	histMenuItem=fileMenu->AppendSubMenu(histMenu,_("History"),_("Go to saved path"));
	if(!OptionsHandler::getOption(_T("/tree/has_history"),true))
		histMenuItem->Enable(false);
	fileMenu->AppendSeparator();
	fileMenu->Append ( idMenuQuit, _ ( "&Quit\tAlt-F4" ), _ ( "Exit application" ) );
	mbar->Append ( fileMenu, _ ( "&File" ) );

	editMenu = new wxMenu ( _T ( "" ) );
	editMenu->Append ( idMenuRefresh, _ ( "&Refresh\tF5" ), _ ( "Refresh the list" ) );
	editMenu->Append ( idMenuDel, _ ( "&Delete\tDel" ), _ ( "Delete selected line(s)" ) );
	editMenu->Append ( idMenuSel, _ ( "&Select all\tCtrl-A" ), _ ( "Select all items" ) );
	editMenu->Enable(idMenuDel,false);
	editMenu->Enable(idMenuSel,false);
	editMenu->AppendSeparator();
	editMenu->Append ( idMenuOp, _ ( "&Options" ), _ ( "Custom music organizer" ) );

	mbar->Append ( editMenu, _ ( "&Edit" ) );

	wxMenu* helpMenu = new wxMenu ( _T ( "" ) );
	helpMenu->Append ( idMenuHelp, _ ( "&Help\tF1" ), _ ( "Online help" ) );
	helpMenu->Append ( idMenuAbout, _ ( "About" ), _ ( "About" ) );
	mbar->Append ( helpMenu, _ ( "&?" ) );


	SetMenuBar ( mbar );
#endif // wxUSE_MENUS

	// create a status bar with some information about the used wxWidgets version
	CreateStatusBar ( 1 );
	SetStatusText ( _ ( "Welcome!" ),0 );

	//create and show the splashscreen
	wxImage* splash = new wxImage();
	splash->AddHandler ( new wxPNGHandler() );
#ifdef __WXMAC__
	if(wxFileExists( _T ( "splashscreen.png" ) ))
		splash->LoadFile ( _T ( "splashscreen.png" ) );
	else
		splash->LoadFile ( MusicOrganizer::stFindResourceFile ( "splashscreen","png" ));
#else
	splash->LoadFile ( _T ( "splashscreen.png" ) );
#endif
	wxSplashScreen* spl=new wxSplashScreen ( wxBitmap ( *splash ),wxSPLASH_CENTRE_ON_SCREEN|wxSPLASH_NO_TIMEOUT , 0,NULL,wxID_ANY,
	        wxDefaultPosition, wxDefaultSize,wxSIMPLE_BORDER|wxSTAY_ON_TOP );

	//set application icon
#ifndef __WXMSW__
	wxIcon icone=wxIcon ( icon_xpm );
	SetIcon(icone);
#else ifndef __WXMAC__
	wxIcon icone=wxIcon(_T("A"));//A is the name in the .rc file
	SetIcon(icone);
#endif
	SetMinSize(wxSize(720,500));

	//Create and organize all components, panels and sizer
	sp=new wxSplitterWindow ( this,wxSP_LIVE_UPDATE );//window with a draggable splitter
	sp->SetMinimumPaneSize(10);
	panel3=new wxPanel ( this );
	tabControl=new MonBook ( panel3 );
	panel2=new ListCtrlPanel ( sp,tabControl );
	tabControl->setChoicebook ( panel2->getCb());
	panel1=new wxPanel ( sp );
	cp=new ComboPath(tabControl,panel1,wxID_ANY,_T(""), wxDefaultPosition,wxDefaultSize,wxArrayString(),wxCB_SORT|wxTE_PROCESS_ENTER);

	arbo=new MonArbo ( panel1,panel2->getCb(),tabControl );
	cp->setMonArbo(arbo);
	cp->SetValue(arbo->GetPath());
	tabControl->setArbo ( arbo );
	panel2->getCb()->getMListeV2()->setArbo(arbo);
	panel2->getCb()->getMListeV1()->setArbo(arbo);

	wxBoxSizer* sizer= new wxBoxSizer ( wxVERTICAL );
	wxBoxSizer* sizerArbo = new wxBoxSizer ( wxVERTICAL );
	wxBoxSizer* sizerTab = new wxBoxSizer ( wxHORIZONTAL );

	sizerTab->Add ( tabControl,1, wxEXPAND|wxALL );
	panel3->SetSizer ( sizerTab );
	sizerArbo->Add ( cp,0, wxEXPAND|wxALL );
	sizerArbo->Add ( 0,5,0);
	sizerArbo->Add ( arbo,1, wxEXPAND|wxALL );
	panel1->SetSizer ( sizerArbo );
	arbo->SetDropTarget(new DropTargetCopie(arbo));//allow files be dropped on the tree

	sp->SplitVertically ( panel1,panel2,250 );
	sizer->Add ( sp,1,wxEXPAND|wxALL );
	sizer->Add ( panel3,0,wxEXPAND|wxALL );
	SetSizer ( sizer );
	int sash=OptionsHandler::getOption(_T("/arbo/splitter"),-1);
	if(sash!=-1)//Restore previously saved position of the splitter
		sp->SetSashPosition(sash);

	i=1;
	//initialize history
	cp->clearAll();
	index=OptionsHandler::getOption(_T("/tree/history/index"),0);
	label = OptionsHandler::getOption(_T("/tree/history/path1"));
	if(!OptionsHandler::getOption(_T("/tree/has_history"),true)) label==_T("");
	while(label!=_T("") && i<=10){
	i++;
	if(cp->GetCount()<6)
		cp->addComboBoxItem(label);
	label = OptionsHandler::getOption(wxString::Format(_T("/tree/history/path%d"),i));
	}
	cp->SetStringSelection(arbo->GetPath());
	
	
	SetAutoLayout ( true );
	spl->Destroy();


}

/* ******************************************************************************** */

Music_Organizer__Frame::~Music_Organizer__Frame()
{
}

/* ******************************************************************************** */

void Music_Organizer__Frame::OnClose ( wxCloseEvent &event )
{
        OptionsHandler::setOption(_T("/tree/splitter"),sp->GetSashPosition());//save splitter position
        panel2->getCb()->getMListeV2()->saveColumnsWidth();//save the list columns
        tabControl->saveTabs();
        Destroy();
}

/* ******************************************************************************** */

void Music_Organizer__Frame::OnQuit ( wxCommandEvent &event )
{
        //same as OnClose
        OptionsHandler::setOption(_T("/tree/splitter"),sp->GetSashPosition());
        panel2->getCb()->getMListeV2()->saveColumnsWidth();
        tabControl->saveTabs();
	Destroy();
}

/* ******************************************************************************** */

void Music_Organizer__Frame::OnAbout ( wxCommandEvent &event )
{
	// First we create and fill the info object
	wxAboutDialogInfo info;
	info.SetName ( _T ( "Music Organizer" ) );
	info.SetVersion ( _T ( "2.5" ) );
	info.SetCopyright ( _T ( "(C) 2007-2008 Jackie Team" ) );
	info.SetDescription ( _ ( "\"Music Organizer\" is an musical files' editor. \nFor example it can change tags, organize some files in directory\n and rename them." ) );
	info.SetWebSite ( _T ( "http://www.musicorganizer.org" ), _ ( "Official website" ) );
	info.AddDeveloper ( _T ( "C. Gallet" ) );
	info.AddDeveloper ( _T ( "J. Charles" ) );
	/*info.AddDeveloper ( wxT ( "T. Tournié" ) );//They don't do anything in fact except supporting us
	info.AddDeveloper ( _T ( "V. Petit" ) );//he wrote the first version of the doc*/
	info.SetLicense ( _T ( "http://www.gnu.org/licenses/gpl.html" ) );
	// Then we call wx.AboutBox giving it that info object
	wxAboutBox ( info );

}

/* ******************************************************************************** */

void Music_Organizer__Frame::OnHelp ( wxCommandEvent &event )
{
        //wxLaunchDefaultBrowser(_T ( "http://www.musicorganizer.org/" ));
	wxMimeTypesManager mime;
	wxLocale lc(OptionsHandler::getOption(_T("/app/language"),wxLocale::GetSystemLanguage()));

	//try to find the folder of the localized pdf file
	wxString lng=lc.GetCanonicalName();
	lng=lng.Mid(0,lng.Length()-lng.Find(_T("_"))-1);
	const wxString sep(wxFileName::GetPathSeparator());
	wxString docd=_T ( "./doc")+sep+lng ;
	wxString defaultdocd=_T ( "./doc")+sep+_T("en") ;
#ifdef __WXMAC__
	if(!wxDirExists( _T ( "./doc/")+lng  )){
		wxString path1= MusicOrganizer::stFindResourceFile ("doc","" );
		docd=path1+_T("/")+lng;
		defaultdocd=path1+_T("/en");
	}
#endif

    if(wxDirExists(docd) || wxDirExists(defaultdocd)){//if the folder exist
	wxString file=docd+sep+_T("docMO.pdf");
	wxString defaultfile=defaultdocd+sep+_T("docMO.pdf");
	wxLogNull ln;
	if (wxFileExists(file)){//if the localized pdf exist
                //try to open it
		wxString cmd = mime.GetFileTypeFromExtension(_T("pdf"))->GetOpenCommand(file);
		if (cmd != _T(""))//there's a software which open pdf files
			wxExecute(cmd);
		else
			wxMessageBox(_("The documentation is a pdf file and you don't have any software to open this kind of files like Adobe Acrobat Reader"));
	}else if(wxFileExists(defaultfile)){//if the english pdf exists
                //try to open it
		wxString cmd = mime.GetFileTypeFromExtension(_T("pdf"))->GetOpenCommand(defaultfile);
		if (cmd != _T(""))//there's a software which open pdf files
			wxExecute(cmd);
		else
			wxMessageBox(_("The documentation is a pdf file and you don't have any software to open this kind of files like Adobe Acrobat Reader"));
	}else{//go to online doc and warn the user
		wxLaunchDefaultBrowser(_T ( "http://www.musicorganizer.org/" ));
		wxMessageBox(_("Warning! No documentation found in Music Organizer folder"));
	}

    }

}

/* ******************************************************************************** */

void Music_Organizer__Frame::onRefresh(wxCommandEvent& event){
       wxCommandEvent e( wxEVT_COMMAND_MENU_SELECTED, MusicOrganizer::ID_REFRESH);
       wxPostEvent(panel2->getCb()->getMListeV2(), e );
}

/* ******************************************************************************** */

void Music_Organizer__Frame::onDel(wxCommandEvent& event){
       wxWindow* w=wxWindow::FindFocus();
       if(w->IsKindOf(CLASSINFO(wxTextCtrl))){
           wxTextCtrl* t=(wxTextCtrl*)w;
           wxString s = t->GetValue();
           if(s.Length()>0 && t->GetInsertionPoint()<=t->GetLastPosition() && t->GetStringSelection()==_T(""))
               t->Remove(t->GetInsertionPoint(),t->GetInsertionPoint()+1);
           else if(t->GetStringSelection()!=_T("")){
               long f,to;
               t->GetSelection(&f,&to);
               t->Remove(f,to);
           }else
               wxBell();
           return;
       }
       wxCommandEvent e( wxEVT_COMMAND_MENU_SELECTED, MusicOrganizer::ID_DEL);
       wxPostEvent(panel2->getCb()->getMListeV2(), e );
}

/* ******************************************************************************** */

void Music_Organizer__Frame::onSel(wxCommandEvent& event){
       wxWindow* w=wxWindow::FindFocus();
       if(w->IsKindOf(CLASSINFO(wxTextCtrl))){
           wxTextCtrl* t=(wxTextCtrl*)w;
           t->SetSelection(-1,-1);
           return;
       }
       wxCommandEvent e( wxEVT_COMMAND_MENU_SELECTED, MusicOrganizer::ID_SEL);
       wxPostEvent(panel2->getCb()->getMListeV2(), e );
}

/* ******************************************************************************** */

void Music_Organizer__Frame::onOp(wxCommandEvent& event){
   opd = new OptionsDialog(this);
   opd->Center();
   opd->Show();
}

/* ******************************************************************************** */

void Music_Organizer__Frame::changeMenu(wxCommandEvent& event){
   int op=event.GetInt();
   if(op==-1){//disable the 2 items
	editMenu->Enable(idMenuDel,false);
	editMenu->Enable(idMenuSel,false);
   }else if(op==0){//enable the 2 items
	editMenu->Enable(idMenuDel,true);
	editMenu->Enable(idMenuSel,true);
   }else if(op==1){//enable only the 1st
	editMenu->Enable(idMenuDel,true);
	editMenu->Enable(idMenuSel,false);
   }else if(op==2){//enable only the 2nd
	editMenu->Enable(idMenuDel,false);
	editMenu->Enable(idMenuSel,true);
   }
}

/* ******************************************************************************** */

void Music_Organizer__Frame::onKeyUp(wxKeyEvent& e){
   panel2->getCb()->getMListeV2()->unblockKeyEvent();
   e.Skip();
}

/* ******************************************************************************** */

void Music_Organizer__Frame::SetPath(wxString p){
   arbo->setIgnore(true);
   arbo->SetPath(p);
   cp->SetValue(p);
   arbo->setIgnore(false);
}

/* ******************************************************************************** */

void Music_Organizer__Frame::changePath(wxCommandEvent& event){
   int diff=(event.GetId()-MusicOrganizer::ID_HIST)-OptionsHandler::getOption(_T("/tree/history/index"),0);
   arbo->historyGo(diff);
}

/* ******************************************************************************** */

void Music_Organizer__Frame::updateHist(wxCommandEvent& event){
        wxMenuItem* item;
        int i=1;
        item=histMenu->FindItem(MusicOrganizer::ID_HIST+1);
        wxString label;
        int index=OptionsHandler::getOption(_T("/tree/history/index"),0);
        //delete all child
        while(item!=NULL){
            i++;
            histMenu->Destroy(item);
            item=histMenu->FindItem(MusicOrganizer::ID_HIST+i);
        }
        cp->clearAll();
        if(event.GetInt()==1){//from Option Dialog, to option has changed
             if(OptionsHandler::getOption(_T("/tree/has_history"),true))
                 histMenuItem->Enable(true);
             else{
                 histMenuItem->Enable(false);
                 cp->SetValue(arbo->GetPath());
                 return;//The function end here is this case
             }
        }
        i=1;
        label = OptionsHandler::getOption(_T("/tree/history/path1"));
        if(!OptionsHandler::getOption(_T("/tree/has_history"),true)) label==_T("");
        while(label!=_T("") && i<=10){//for each history item
             item=histMenu->AppendRadioItem(MusicOrganizer::ID_HIST+i,label);//add the radioitem to the menu
             if(i==index) item->Check();
             i++;
             if(cp->GetCount()<6)//then update the combopath
                cp->addComboBoxItem(label);
             label = OptionsHandler::getOption(wxString::Format(_T("/tree/history/path%d"),i));
        }
        cp->SetValue(arbo->GetPath());

}
