/***************************************************************************
 * Name:      Music_Organizer__Main.h                                      *
 * Purpose:   Defines Application Frame                                    *
 * Author:    Jackie Team (jackie.team@gmail.com)                          *
 * Created:   2007-11-26                                                   *
 * Copyright: Jackie Team (www.musicorganizer.org)                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MUSIC_ORGANIZER__MAIN_H
#define MUSIC_ORGANIZER__MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "Music_Organizer__App.h"
#include <wx/splitter.h>
#include <wx/splash.h>
#include <wx/icon.h>
#include <wx/aboutdlg.h>
#include <wx/hyperlink.h>
#include <wx/font.h>

#include "options_Dialog.h"
#include "components.h"

/**
 * This is the class for the top-level window
 */
class Music_Organizer__Frame: public wxFrame
{
    public:
        Music_Organizer__Frame(wxFrame *frame, const wxString& title);
        /**
         *set the path from the top-level
         *@param wxString the path
         */
        void SetPath(wxString);
        ~Music_Organizer__Frame();
    private:
        enum
        {
            idMenuRefresh=130,
            idMenuDel,
            idMenuSel,
            idMenuOp,
            idMenuQuit = 1000,
            idMenuAbout,
            idMenuHelp
        };
        wxLocale m_locale;
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnHelp(wxCommandEvent& event);
        void onRefresh(wxCommandEvent& event);
        void onDel(wxCommandEvent& event);
        void onSel(wxCommandEvent& event);
        void onOp(wxCommandEvent& event);
        void changePath(wxCommandEvent& event);
        void onKeyUp(wxKeyEvent&);
        void changeMenu(wxCommandEvent& event);
        void updateHist(wxCommandEvent& event);
        wxPanel* panel1;
        wxPanel* panel3;
        MonArbo* arbo;
        MonBook* tabControl;
        ListCtrlPanel* panel2;
        OptionsDialog* opd;
        wxMenu* editMenu,*histMenu;
        wxMenuItem* histMenuItem;
        wxSplitterWindow* sp;
        ComboPath *cp;

        DECLARE_EVENT_TABLE()
};

#endif // MUSIC_ORGANIZER__MAIN_H
