/***************************************************************************
 * Name:      WaitPopup.cpp                                                *
 * Purpose:   Code for the wait message popup                              *
 * Author:    Jackie Team (jackie.team@gmail.com)                          *
 * Created:   2007-12-16                                                   *
 * Copyright: Jackie Team (http://www.musicorganizer.org)                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "components.h"
#ifndef __WXMAC__
BEGIN_EVENT_TABLE(WaitPopup, wxPopupWindow)
#else
BEGIN_EVENT_TABLE(WaitPopup, wxMiniFrame)
#endif
    EVT_BUTTON( MusicOrganizer::ID_ANNULER, WaitPopup::Cancel )
END_EVENT_TABLE()

#ifndef __WXMAC__
WaitPopup::WaitPopup(MonArbo* parent):wxPopupWindow(parent->GetGrandParent()->GetParent()){
#else
WaitPopup::WaitPopup(MonArbo* parent):wxMiniFrame(parent->GetGrandParent()->GetParent(),wxID_ANY,_T(""),wxDefaultPosition,wxDefaultSize,0){
#endif
    wxScrolledWindow *m_panel = new wxScrolledWindow( this, wxID_ANY );
    m_panel->SetBackgroundColour(*wxLIGHT_GREY);
    wxStaticText *text = new wxStaticText( m_panel , wxID_ANY,_(" Please wait\n Directory scanning"));
    wxButton *annuler = new wxButton(m_panel,MusicOrganizer::ID_ANNULER,_("Cancel"));
    wxBoxSizer *topSizer = new wxBoxSizer( wxVERTICAL );
    topSizer->Add( text, 0, wxALL, 5 );

    m_panel->SetAutoLayout( true );
    m_panel->SetSizer( topSizer );
    topSizer->Add( annuler, 0, wxALL, 5 );
    topSizer->Fit(m_panel);
    topSizer->Fit(this);
    ma=parent;
}

void WaitPopup::Cancel(wxCommandEvent& event){
    //abort scanning
    ma->stopThread();
}
