/***************************************************************************
 * Name:      checklistctrl.h                                              *
 * Purpose:   header for the listctrl with checkbox                        *
 * Author:    Jackie Team (jackie.team@gmail.com)                          *
 * Created:   2007-11-26                                                   *
 * Copyright: Jackie Team (http://www.musicorganizer.org)                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _WX_CHECKLISTCTRL_H_
#define _WX_CHECKLISTCTRL_H_

#include <wx/listctrl.h>
#include <wx/imaglist.h>
#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

	/**
	 * wxCheckListCtrl
	 * A listctrl whith checkboxes at the left of each line
	 */

	class wxCheckListCtrl: public wxListCtrl
	{
		DECLARE_CLASS(wxCheckListCtrl)
		public:
			wxCheckListCtrl(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pt = wxDefaultPosition,
				const wxSize& sz = wxDefaultSize, long style = wxLC_REPORT);
			virtual ~wxCheckListCtrl();


			//// Accessors

			/**
			 * Load the icons
			 */
			bool LoadIcons();

			/** 
			 * Set the appropriate icon
			 * @param long the item
			 * @param int what to do : -1 inverse state, 1 check, 0 uncheck
			 */
			bool SetIcon(long& item,int=-1);

            		/**
			 * retrieve the state of an item
			 * @param long the item
			 * @return true if checked false otherwise
			 */
			bool IsChecked(long item);

			/**
			 * get next selected item
			 * @param int the previous item
			 * @return the next item
			 */
			long getSelection(int);

		protected:
			wxImageList*        m_imageList;
			// Event handlers
			void OnMouseEvent(wxMouseEvent& event);
			void OnKeyDown(wxKeyEvent& event);
			void onContextMenu(wxContextMenuEvent& event);
			void onCheck(wxCommandEvent& WXUNUSED(event));
        		void onUncheck(wxCommandEvent& WXUNUSED(event));
			enum{UNCHECK_ICON=1,CHECK_ICON=0,ID_CHECK=444,ID_UNCHECK};
			DECLARE_EVENT_TABLE()
	};
#endif		// _WB_CHECKLISTCTRL_H_
