/***************************************************************************
 *   Copyright (C) 2007 by Jackie Team                                     *
 *   jackie.team@gmail.com                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef OPTIONS_DIALOG_H
#define OPTIONS_DIALOG_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif
#include "Options_Handler.h"
#include <wx/regex.h>
#include <wx/toolbook.h>
#include <wx/listbook.h>
#include <wx/imaglist.h>
#include <wx/dir.h>
#include <wx/filename.h>
#include <wx/checkbox.h>
#include <wx/sizer.h>
#include <wx/statbox.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/panel.h>
#include <wx/bitmap.h>
#include <wx/image.h>
#include <wx/combobox.h>
#include <wx/radiobut.h>
#include <wx/button.h>
#include <wx/frame.h>

#ifdef __WXMAC__
// For most stuff
#include <Carbon/Carbon.h>
// For bundle-related stuff
#include <CFBundle.h>
#endif


WX_DEFINE_ARRAY_INT(int, ArrayOfInts);

//some informations and function shared by some classes
namespace MusicOrganizer{
    enum{
    ID_REFRESH=13,
    ID_DEL,
    ID_SEL,
    ID_HIST=10101,
    ID_MSG=7777,
    ID_ANNULER=1758,
    ID_VALIDER
    };
#ifdef __WXMAC__

/**
 *Find the absolute path of a file (it may be a folder) in the resource directory
 *@param char* the name of the file to find without extension
 *@param char* the extension of the file, it may be empty
 *@return the absolute path if found, empty wxString otherwise
 */
wxString stFindResourceFile(const char * name, const char * extension);
#endif
};


/**
 *List all subdirectories of a folder non recursively
 */
class DirLister : public wxDirTraverser
{
    public:
        DirLister(wxArrayString* files);

        virtual wxDirTraverseResult OnFile(const wxString&  WXUNUSED(filename));

        virtual wxDirTraverseResult OnDir(const wxString& dirname);

    private:
        wxArrayString* m_files;
};

/**
 *This class draw a frame which show all avaible options and allow user
 *to edit them
 */
class OptionsDialog : public wxFrame{
    public:
	OptionsDialog( wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& title = _("Options"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE& ~ ( wxRESIZE_BORDER | wxRESIZE_BOX | wxMAXIMIZE_BOX ) | wxFRAME_FLOAT_ON_PARENT );

	~OptionsDialog();

    private:
        void save(wxCommandEvent& e);
        void cancel(wxCommandEvent& e);
        void textWriting(wxCommandEvent& event);
        void choosePlayer(wxCommandEvent& event);
        void onRadioButton(wxCommandEvent& event);
        wxString text;
        wxButton* btnSave;
        wxButton* btnCancel;
        wxButton* btnPlayer;
        wxTextCtrl* defaultReplaceChar;
        wxTextCtrl* customPlayer;
        wxTextCtrl* ucSymbols;
        wxCheckBox* saveDir;
        wxCheckBox* directorySort;
        wxCheckBox* delEmptyFolders;
        wxCheckBox* saveTabs;
        wxCheckBox* recursiveScan;
        wxCheckBox* saveHist;
        wxChoice* langs;
        ArrayOfInts langsId;
        wxToolbook* toolBook;
        wxRadioButton* radioDefaultPlayer;
        wxRadioButton* radioPersoPlayer;
        enum{ID_CANCEL=55,ID_SAVE,ID_REPLACE,ID_PLAYER,ID_PLAYER_TXT,ID_RBPLAYER,ID_CAPITALIZE};
        DECLARE_EVENT_TABLE()
};


#endif
